import static rules2cp.interpreter.java.r2cp.*;
import rules2cp.interpreter.java.*;
import java.util.Vector;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.cp.solver.search.integer.varselector.*;
import choco.cp.solver.search.integer.valselector.*;
import choco.cp.solver.search.integer.valiterator.*;
import choco.cp.solver.search.integer.branching.*;
import choco.cp.solver.constraints.integer.*;
import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.*;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.variables.geost.GeostObject;
import choco.kernel.solver.Solver;
import choco.kernel.solver.branch.*;
import choco.kernel.solver.variables.integer.*;
import choco.kernel.model.variables.geost.*;

public class psa {

  public static void main(String[] args) {

    IntegerVariable reif_477 = makeIntVar("reif_477", 0, 1);
    IntegerVariable reif_478 = makeIntVar("reif_478", 0, 1);
    IntegerVariable reif_479 = makeIntVar("reif_479", 0, 1);
    IntegerVariable reif_480 = makeIntVar("reif_480", 0, 1);
    IntegerVariable reif_481 = makeIntVar("reif_481", 0, 1);
    IntegerVariable reif_482 = makeIntVar("reif_482", 0, 1);
    IntegerVariable reif_483 = makeIntVar("reif_483", 0, 1);
    IntegerVariable reif_484 = makeIntVar("reif_484", 0, 1);
    IntegerVariable reif_485 = makeIntVar("reif_485", 0, 1);
    IntegerVariable reif_486 = makeIntVar("reif_486", 0, 1);
    IntegerVariable reif_487 = makeIntVar("reif_487", 0, 1);
    IntegerVariable reif_488 = makeIntVar("reif_488", 0, 1);
    IntegerVariable reif_489 = makeIntVar("reif_489", 0, 1);
    IntegerVariable reif_490 = makeIntVar("reif_490", 0, 1);
    IntegerVariable reif_491 = makeIntVar("reif_491", 0, 1);
    IntegerVariable reif_492 = makeIntVar("reif_492", 0, 1);
    IntegerVariable reif_493 = makeIntVar("reif_493", 0, 1);
    IntegerVariable reif_494 = makeIntVar("reif_494", 0, 1);
    IntegerVariable reif_495 = makeIntVar("reif_495", 0, 1);
    IntegerVariable reif_496 = makeIntVar("reif_496", 0, 1);
    IntegerVariable reif_497 = makeIntVar("reif_497", 0, 1);
    IntegerVariable reif_498 = makeIntVar("reif_498", 0, 1);
    IntegerVariable reif_499 = makeIntVar("reif_499", 0, 1);
    IntegerVariable reif_500 = makeIntVar("reif_500", 0, 1);
    IntegerVariable reif_501 = makeIntVar("reif_501", 0, 1);
    IntegerVariable reif_502 = makeIntVar("reif_502", 0, 1);
    IntegerVariable reif_503 = makeIntVar("reif_503", 0, 1);
    IntegerVariable reif_504 = makeIntVar("reif_504", 0, 1);
    IntegerVariable reif_505 = makeIntVar("reif_505", 0, 1);
    IntegerVariable reif_506 = makeIntVar("reif_506", 0, 1);
    IntegerVariable reif_507 = makeIntVar("reif_507", 0, 1);
    IntegerVariable reif_508 = makeIntVar("reif_508", 0, 1);
    IntegerVariable reif_509 = makeIntVar("reif_509", 0, 1);
    IntegerVariable reif_510 = makeIntVar("reif_510", 0, 1);
    IntegerVariable reif_511 = makeIntVar("reif_511", 0, 1);
    IntegerVariable reif_512 = makeIntVar("reif_512", 0, 1);
    IntegerVariable o4_3 = rcp_var("from(o4, 3)");
    IntegerVariable o4 = rcp_var("from(o4, 1)");
    IntegerVariable o4_2 = rcp_var("from(o4, 2)");
    IntegerVariable o8_3 = rcp_var("from(o8, 3)");
    IntegerVariable o8 = rcp_var("from(o8, 1)");
    IntegerVariable o8_2 = rcp_var("from(o8, 2)");
    IntegerVariable o3_3 = rcp_var("from(o3, 3)");
    IntegerVariable o3 = rcp_var("from(o3, 1)");
    IntegerVariable o3_2 = rcp_var("from(o3, 2)");
    IntegerVariable o9_3 = rcp_var("from(o9, 3)");
    IntegerVariable o9 = rcp_var("from(o9, 1)");
    IntegerVariable o9_2 = rcp_var("from(o9, 2)");
    IntegerVariable o5_3 = rcp_var("from(o5, 3)");
    IntegerVariable o5 = rcp_var("from(o5, 1)");
    IntegerVariable o5_2 = rcp_var("from(o5, 2)");
    IntegerVariable o2_3 = rcp_var("from(o2, 3)");
    IntegerVariable o2 = rcp_var("from(o2, 1)");
    IntegerVariable o2_2 = rcp_var("from(o2, 2)");
    IntegerVariable o10_3 = rcp_var("from(o10, 3)");
    IntegerVariable o10 = rcp_var("from(o10, 1)");
    IntegerVariable o10_2 = rcp_var("from(o10, 2)");
    IntegerVariable o7_3 = rcp_var("from(o7, 3)");
    IntegerVariable o7 = rcp_var("from(o7, 1)");
    IntegerVariable o7_2 = rcp_var("from(o7, 2)");
    IntegerVariable o6_3 = rcp_var("from(o6, 3)");
    IntegerVariable o6 = rcp_var("from(o6, 1)");
    IntegerVariable o6_2 = rcp_var("from(o6, 2)");
    addConstraint(reifiedIntConstraint(reif_477, leq(plus(o2, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_478, leq(plus(o3, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_479, leq(plus(o4, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_480, leq(plus(o5, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_481, leq(plus(o6, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_482, leq(plus(o7, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_483, leq(plus(o8, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_484, leq(plus(o9, 155), 601)));
    addConstraint(reifiedIntConstraint(reif_485, leq(plus(o10, 112), 601)));
    addConstraint(reifiedIntConstraint(reif_486, geq(o2, 601)));
    addConstraint(reifiedIntConstraint(reif_487, geq(o3, 601)));
    addConstraint(reifiedIntConstraint(reif_488, geq(o4, 601)));
    addConstraint(reifiedIntConstraint(reif_489, geq(o5, 601)));
    addConstraint(reifiedIntConstraint(reif_490, geq(o6, 601)));
    addConstraint(reifiedIntConstraint(reif_491, geq(o7, 601)));
    addConstraint(reifiedIntConstraint(reif_492, geq(o8, 601)));
    addConstraint(reifiedIntConstraint(reif_493, geq(o9, 601)));
    addConstraint(reifiedIntConstraint(reif_494, geq(o10, 601)));
    addConstraint(reifiedIntConstraint(reif_495, leq(plus(o2, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_496, leq(plus(o3, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_497, leq(plus(o4, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_498, leq(plus(o5, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_499, leq(plus(o6, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_500, leq(plus(o7, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_501, leq(plus(o8, 224), 601)));
    addConstraint(reifiedIntConstraint(reif_502, leq(plus(o9, 155), 601)));
    addConstraint(reifiedIntConstraint(reif_503, leq(plus(o10, 112), 601)));
    addConstraint(reifiedIntConstraint(reif_504, geq(o2, 601)));
    addConstraint(reifiedIntConstraint(reif_505, geq(o3, 601)));
    addConstraint(reifiedIntConstraint(reif_506, geq(o4, 601)));
    addConstraint(reifiedIntConstraint(reif_507, geq(o5, 601)));
    addConstraint(reifiedIntConstraint(reif_508, geq(o6, 601)));
    addConstraint(reifiedIntConstraint(reif_509, geq(o7, 601)));
    addConstraint(reifiedIntConstraint(reif_510, geq(o8, 601)));
    addConstraint(reifiedIntConstraint(reif_511, geq(o9, 601)));
    addConstraint(reifiedIntConstraint(reif_512, geq(o10, 601)));
    domain(new IntegerVariable[] {o2}, 0, 979);
    domain(new IntegerVariable[] {o2_2}, 0, 11);
    domain(new IntegerVariable[] {o2_3}, 0, 128);
    domain(new IntegerVariable[] {o3}, 0, 979);
    domain(new IntegerVariable[] {o3_2}, 0, 11);
    domain(new IntegerVariable[] {o3_3}, 0, 165);
    domain(new IntegerVariable[] {o4}, 0, 979);
    domain(new IntegerVariable[] {o4_2}, 0, 11);
    domain(new IntegerVariable[] {o4_3}, 0, 165);
    domain(new IntegerVariable[] {o5}, 0, 979);
    domain(new IntegerVariable[] {o5_2}, 0, 11);
    domain(new IntegerVariable[] {o5_3}, 0, 91);
    domain(new IntegerVariable[] {o6}, 0, 979);
    domain(new IntegerVariable[] {o6_2}, 0, 11);
    domain(new IntegerVariable[] {o6_3}, 0, 128);
    domain(new IntegerVariable[] {o7}, 0, 979);
    domain(new IntegerVariable[] {o7_2}, 0, 11);
    domain(new IntegerVariable[] {o7_3}, 0, 128);
    domain(new IntegerVariable[] {o8}, 0, 979);
    domain(new IntegerVariable[] {o8_2}, 0, 11);
    domain(new IntegerVariable[] {o8_3}, 0, 17);
    domain(new IntegerVariable[] {o9}, 0, 1048);
    domain(new IntegerVariable[] {o9_2}, 0, 11);
    domain(new IntegerVariable[] {o9_3}, 0, 17);
    domain(new IntegerVariable[] {o10}, 0, 1091);
    domain(new IntegerVariable[] {o10_2}, 0, 11);
    domain(new IntegerVariable[] {o10_3}, 0, 91);
    addConstraint(or(eq(o2_3, 0), or(and(and(and(gt(plus(o2, 224), o3), gt(plus(o3, 224), o2)), and(gt(plus(o2_2, 224), o3_2), gt(plus(o3_2, 224), o2_2))), eq(plus(o3_3, 74), o2_3)), or(and(and(and(gt(plus(o2, 224), o4), gt(plus(o4, 224), o2)), and(gt(plus(o2_2, 224), o4_2), gt(plus(o4_2, 224), o2_2))), eq(plus(o4_3, 74), o2_3)), or(and(and(and(gt(plus(o2, 224), o5), gt(plus(o5, 224), o2)), and(gt(plus(o2_2, 224), o5_2), gt(plus(o5_2, 224), o2_2))), eq(plus(o5_3, 148), o2_3)), or(and(and(and(gt(plus(o2, 224), o6), gt(plus(o6, 224), o2)), and(gt(plus(o2_2, 224), o6_2), gt(plus(o6_2, 224), o2_2))), eq(plus(o6_3, 111), o2_3)), or(and(and(and(gt(plus(o2, 224), o7), gt(plus(o7, 224), o2)), and(gt(plus(o2_2, 224), o7_2), gt(plus(o7_2, 224), o2_2))), eq(plus(o7_3, 111), o2_3)), or(and(and(and(gt(plus(o2, 224), o8), gt(plus(o8, 224), o2)), and(gt(plus(o2_2, 224), o8_2), gt(plus(o8_2, 224), o2_2))), eq(plus(o8_3, 222), o2_3)), or(and(and(and(gt(plus(o2, 224), o9), gt(plus(o9, 155), o2)), and(gt(plus(o2_2, 224), o9_2), gt(plus(o9_2, 224), o2_2))), eq(plus(o9_3, 222), o2_3)), and(and(and(gt(plus(o2, 224), o10), gt(plus(o10, 112), o2)), and(gt(plus(o2_2, 224), o10_2), gt(plus(o10_2, 224), o2_2))), eq(plus(o10_3, 148), o2_3)))))))))));
    addConstraint(or(eq(o3_3, 0), or(and(and(and(gt(plus(o3, 224), o2), gt(plus(o2, 224), o3)), and(gt(plus(o3_2, 224), o2_2), gt(plus(o2_2, 224), o3_2))), eq(plus(o2_3, 111), o3_3)), or(and(and(and(gt(plus(o3, 224), o4), gt(plus(o4, 224), o3)), and(gt(plus(o3_2, 224), o4_2), gt(plus(o4_2, 224), o3_2))), eq(plus(o4_3, 74), o3_3)), or(and(and(and(gt(plus(o3, 224), o5), gt(plus(o5, 224), o3)), and(gt(plus(o3_2, 224), o5_2), gt(plus(o5_2, 224), o3_2))), eq(plus(o5_3, 148), o3_3)), or(and(and(and(gt(plus(o3, 224), o6), gt(plus(o6, 224), o3)), and(gt(plus(o3_2, 224), o6_2), gt(plus(o6_2, 224), o3_2))), eq(plus(o6_3, 111), o3_3)), or(and(and(and(gt(plus(o3, 224), o7), gt(plus(o7, 224), o3)), and(gt(plus(o3_2, 224), o7_2), gt(plus(o7_2, 224), o3_2))), eq(plus(o7_3, 111), o3_3)), or(and(and(and(gt(plus(o3, 224), o8), gt(plus(o8, 224), o3)), and(gt(plus(o3_2, 224), o8_2), gt(plus(o8_2, 224), o3_2))), eq(plus(o8_3, 222), o3_3)), or(and(and(and(gt(plus(o3, 224), o9), gt(plus(o9, 155), o3)), and(gt(plus(o3_2, 224), o9_2), gt(plus(o9_2, 224), o3_2))), eq(plus(o9_3, 222), o3_3)), and(and(and(gt(plus(o3, 224), o10), gt(plus(o10, 112), o3)), and(gt(plus(o3_2, 224), o10_2), gt(plus(o10_2, 224), o3_2))), eq(plus(o10_3, 148), o3_3)))))))))));
    addConstraint(or(eq(o4_3, 0), or(and(and(and(gt(plus(o4, 224), o2), gt(plus(o2, 224), o4)), and(gt(plus(o4_2, 224), o2_2), gt(plus(o2_2, 224), o4_2))), eq(plus(o2_3, 111), o4_3)), or(and(and(and(gt(plus(o4, 224), o3), gt(plus(o3, 224), o4)), and(gt(plus(o4_2, 224), o3_2), gt(plus(o3_2, 224), o4_2))), eq(plus(o3_3, 74), o4_3)), or(and(and(and(gt(plus(o4, 224), o5), gt(plus(o5, 224), o4)), and(gt(plus(o4_2, 224), o5_2), gt(plus(o5_2, 224), o4_2))), eq(plus(o5_3, 148), o4_3)), or(and(and(and(gt(plus(o4, 224), o6), gt(plus(o6, 224), o4)), and(gt(plus(o4_2, 224), o6_2), gt(plus(o6_2, 224), o4_2))), eq(plus(o6_3, 111), o4_3)), or(and(and(and(gt(plus(o4, 224), o7), gt(plus(o7, 224), o4)), and(gt(plus(o4_2, 224), o7_2), gt(plus(o7_2, 224), o4_2))), eq(plus(o7_3, 111), o4_3)), or(and(and(and(gt(plus(o4, 224), o8), gt(plus(o8, 224), o4)), and(gt(plus(o4_2, 224), o8_2), gt(plus(o8_2, 224), o4_2))), eq(plus(o8_3, 222), o4_3)), or(and(and(and(gt(plus(o4, 224), o9), gt(plus(o9, 155), o4)), and(gt(plus(o4_2, 224), o9_2), gt(plus(o9_2, 224), o4_2))), eq(plus(o9_3, 222), o4_3)), and(and(and(gt(plus(o4, 224), o10), gt(plus(o10, 112), o4)), and(gt(plus(o4_2, 224), o10_2), gt(plus(o10_2, 224), o4_2))), eq(plus(o10_3, 148), o4_3)))))))))));
    addConstraint(or(eq(o5_3, 0), or(and(and(and(gt(plus(o5, 224), o2), gt(plus(o2, 224), o5)), and(gt(plus(o5_2, 224), o2_2), gt(plus(o2_2, 224), o5_2))), eq(plus(o2_3, 111), o5_3)), or(and(and(and(gt(plus(o5, 224), o3), gt(plus(o3, 224), o5)), and(gt(plus(o5_2, 224), o3_2), gt(plus(o3_2, 224), o5_2))), eq(plus(o3_3, 74), o5_3)), or(and(and(and(gt(plus(o5, 224), o4), gt(plus(o4, 224), o5)), and(gt(plus(o5_2, 224), o4_2), gt(plus(o4_2, 224), o5_2))), eq(plus(o4_3, 74), o5_3)), or(and(and(and(gt(plus(o5, 224), o6), gt(plus(o6, 224), o5)), and(gt(plus(o5_2, 224), o6_2), gt(plus(o6_2, 224), o5_2))), eq(plus(o6_3, 111), o5_3)), or(and(and(and(gt(plus(o5, 224), o7), gt(plus(o7, 224), o5)), and(gt(plus(o5_2, 224), o7_2), gt(plus(o7_2, 224), o5_2))), eq(plus(o7_3, 111), o5_3)), or(and(and(and(gt(plus(o5, 224), o8), gt(plus(o8, 224), o5)), and(gt(plus(o5_2, 224), o8_2), gt(plus(o8_2, 224), o5_2))), eq(plus(o8_3, 222), o5_3)), or(and(and(and(gt(plus(o5, 224), o9), gt(plus(o9, 155), o5)), and(gt(plus(o5_2, 224), o9_2), gt(plus(o9_2, 224), o5_2))), eq(plus(o9_3, 222), o5_3)), and(and(and(gt(plus(o5, 224), o10), gt(plus(o10, 112), o5)), and(gt(plus(o5_2, 224), o10_2), gt(plus(o10_2, 224), o5_2))), eq(plus(o10_3, 148), o5_3)))))))))));
    addConstraint(or(eq(o6_3, 0), or(and(and(and(gt(plus(o6, 224), o2), gt(plus(o2, 224), o6)), and(gt(plus(o6_2, 224), o2_2), gt(plus(o2_2, 224), o6_2))), eq(plus(o2_3, 111), o6_3)), or(and(and(and(gt(plus(o6, 224), o3), gt(plus(o3, 224), o6)), and(gt(plus(o6_2, 224), o3_2), gt(plus(o3_2, 224), o6_2))), eq(plus(o3_3, 74), o6_3)), or(and(and(and(gt(plus(o6, 224), o4), gt(plus(o4, 224), o6)), and(gt(plus(o6_2, 224), o4_2), gt(plus(o4_2, 224), o6_2))), eq(plus(o4_3, 74), o6_3)), or(and(and(and(gt(plus(o6, 224), o5), gt(plus(o5, 224), o6)), and(gt(plus(o6_2, 224), o5_2), gt(plus(o5_2, 224), o6_2))), eq(plus(o5_3, 148), o6_3)), or(and(and(and(gt(plus(o6, 224), o7), gt(plus(o7, 224), o6)), and(gt(plus(o6_2, 224), o7_2), gt(plus(o7_2, 224), o6_2))), eq(plus(o7_3, 111), o6_3)), or(and(and(and(gt(plus(o6, 224), o8), gt(plus(o8, 224), o6)), and(gt(plus(o6_2, 224), o8_2), gt(plus(o8_2, 224), o6_2))), eq(plus(o8_3, 222), o6_3)), or(and(and(and(gt(plus(o6, 224), o9), gt(plus(o9, 155), o6)), and(gt(plus(o6_2, 224), o9_2), gt(plus(o9_2, 224), o6_2))), eq(plus(o9_3, 222), o6_3)), and(and(and(gt(plus(o6, 224), o10), gt(plus(o10, 112), o6)), and(gt(plus(o6_2, 224), o10_2), gt(plus(o10_2, 224), o6_2))), eq(plus(o10_3, 148), o6_3)))))))))));
    addConstraint(or(eq(o7_3, 0), or(and(and(and(gt(plus(o7, 224), o2), gt(plus(o2, 224), o7)), and(gt(plus(o7_2, 224), o2_2), gt(plus(o2_2, 224), o7_2))), eq(plus(o2_3, 111), o7_3)), or(and(and(and(gt(plus(o7, 224), o3), gt(plus(o3, 224), o7)), and(gt(plus(o7_2, 224), o3_2), gt(plus(o3_2, 224), o7_2))), eq(plus(o3_3, 74), o7_3)), or(and(and(and(gt(plus(o7, 224), o4), gt(plus(o4, 224), o7)), and(gt(plus(o7_2, 224), o4_2), gt(plus(o4_2, 224), o7_2))), eq(plus(o4_3, 74), o7_3)), or(and(and(and(gt(plus(o7, 224), o5), gt(plus(o5, 224), o7)), and(gt(plus(o7_2, 224), o5_2), gt(plus(o5_2, 224), o7_2))), eq(plus(o5_3, 148), o7_3)), or(and(and(and(gt(plus(o7, 224), o6), gt(plus(o6, 224), o7)), and(gt(plus(o7_2, 224), o6_2), gt(plus(o6_2, 224), o7_2))), eq(plus(o6_3, 111), o7_3)), or(and(and(and(gt(plus(o7, 224), o8), gt(plus(o8, 224), o7)), and(gt(plus(o7_2, 224), o8_2), gt(plus(o8_2, 224), o7_2))), eq(plus(o8_3, 222), o7_3)), or(and(and(and(gt(plus(o7, 224), o9), gt(plus(o9, 155), o7)), and(gt(plus(o7_2, 224), o9_2), gt(plus(o9_2, 224), o7_2))), eq(plus(o9_3, 222), o7_3)), and(and(and(gt(plus(o7, 224), o10), gt(plus(o10, 112), o7)), and(gt(plus(o7_2, 224), o10_2), gt(plus(o10_2, 224), o7_2))), eq(plus(o10_3, 148), o7_3)))))))))));
    addConstraint(or(eq(o8_3, 0), or(and(and(and(gt(plus(o8, 224), o2), gt(plus(o2, 224), o8)), and(gt(plus(o8_2, 224), o2_2), gt(plus(o2_2, 224), o8_2))), eq(plus(o2_3, 111), o8_3)), or(and(and(and(gt(plus(o8, 224), o3), gt(plus(o3, 224), o8)), and(gt(plus(o8_2, 224), o3_2), gt(plus(o3_2, 224), o8_2))), eq(plus(o3_3, 74), o8_3)), or(and(and(and(gt(plus(o8, 224), o4), gt(plus(o4, 224), o8)), and(gt(plus(o8_2, 224), o4_2), gt(plus(o4_2, 224), o8_2))), eq(plus(o4_3, 74), o8_3)), or(and(and(and(gt(plus(o8, 224), o5), gt(plus(o5, 224), o8)), and(gt(plus(o8_2, 224), o5_2), gt(plus(o5_2, 224), o8_2))), eq(plus(o5_3, 148), o8_3)), or(and(and(and(gt(plus(o8, 224), o6), gt(plus(o6, 224), o8)), and(gt(plus(o8_2, 224), o6_2), gt(plus(o6_2, 224), o8_2))), eq(plus(o6_3, 111), o8_3)), or(and(and(and(gt(plus(o8, 224), o7), gt(plus(o7, 224), o8)), and(gt(plus(o8_2, 224), o7_2), gt(plus(o7_2, 224), o8_2))), eq(plus(o7_3, 111), o8_3)), or(and(and(and(gt(plus(o8, 224), o9), gt(plus(o9, 155), o8)), and(gt(plus(o8_2, 224), o9_2), gt(plus(o9_2, 224), o8_2))), eq(plus(o9_3, 222), o8_3)), and(and(and(gt(plus(o8, 224), o10), gt(plus(o10, 112), o8)), and(gt(plus(o8_2, 224), o10_2), gt(plus(o10_2, 224), o8_2))), eq(plus(o10_3, 148), o8_3)))))))))));
    addConstraint(or(eq(o9_3, 0), or(and(and(and(gt(plus(o9, 155), o2), gt(plus(o2, 224), o9)), and(gt(plus(o9_2, 224), o2_2), gt(plus(o2_2, 224), o9_2))), eq(plus(o2_3, 111), o9_3)), or(and(and(and(gt(plus(o9, 155), o3), gt(plus(o3, 224), o9)), and(gt(plus(o9_2, 224), o3_2), gt(plus(o3_2, 224), o9_2))), eq(plus(o3_3, 74), o9_3)), or(and(and(and(gt(plus(o9, 155), o4), gt(plus(o4, 224), o9)), and(gt(plus(o9_2, 224), o4_2), gt(plus(o4_2, 224), o9_2))), eq(plus(o4_3, 74), o9_3)), or(and(and(and(gt(plus(o9, 155), o5), gt(plus(o5, 224), o9)), and(gt(plus(o9_2, 224), o5_2), gt(plus(o5_2, 224), o9_2))), eq(plus(o5_3, 148), o9_3)), or(and(and(and(gt(plus(o9, 155), o6), gt(plus(o6, 224), o9)), and(gt(plus(o9_2, 224), o6_2), gt(plus(o6_2, 224), o9_2))), eq(plus(o6_3, 111), o9_3)), or(and(and(and(gt(plus(o9, 155), o7), gt(plus(o7, 224), o9)), and(gt(plus(o9_2, 224), o7_2), gt(plus(o7_2, 224), o9_2))), eq(plus(o7_3, 111), o9_3)), or(and(and(and(gt(plus(o9, 155), o8), gt(plus(o8, 224), o9)), and(gt(plus(o9_2, 224), o8_2), gt(plus(o8_2, 224), o9_2))), eq(plus(o8_3, 222), o9_3)), and(and(and(gt(plus(o9, 155), o10), gt(plus(o10, 112), o9)), and(gt(plus(o9_2, 224), o10_2), gt(plus(o10_2, 224), o9_2))), eq(plus(o10_3, 148), o9_3)))))))))));
    addConstraint(or(eq(o10_3, 0), or(and(and(and(gt(plus(o10, 112), o2), gt(plus(o2, 224), o10)), and(gt(plus(o10_2, 224), o2_2), gt(plus(o2_2, 224), o10_2))), eq(plus(o2_3, 111), o10_3)), or(and(and(and(gt(plus(o10, 112), o3), gt(plus(o3, 224), o10)), and(gt(plus(o10_2, 224), o3_2), gt(plus(o3_2, 224), o10_2))), eq(plus(o3_3, 74), o10_3)), or(and(and(and(gt(plus(o10, 112), o4), gt(plus(o4, 224), o10)), and(gt(plus(o10_2, 224), o4_2), gt(plus(o4_2, 224), o10_2))), eq(plus(o4_3, 74), o10_3)), or(and(and(and(gt(plus(o10, 112), o5), gt(plus(o5, 224), o10)), and(gt(plus(o10_2, 224), o5_2), gt(plus(o5_2, 224), o10_2))), eq(plus(o5_3, 148), o10_3)), or(and(and(and(gt(plus(o10, 112), o6), gt(plus(o6, 224), o10)), and(gt(plus(o10_2, 224), o6_2), gt(plus(o6_2, 224), o10_2))), eq(plus(o6_3, 111), o10_3)), or(and(and(and(gt(plus(o10, 112), o7), gt(plus(o7, 224), o10)), and(gt(plus(o10_2, 224), o7_2), gt(plus(o7_2, 224), o10_2))), eq(plus(o7_3, 111), o10_3)), or(and(and(and(gt(plus(o10, 112), o8), gt(plus(o8, 224), o10)), and(gt(plus(o10_2, 224), o8_2), gt(plus(o8_2, 224), o10_2))), eq(plus(o8_3, 222), o10_3)), and(and(and(gt(plus(o10, 112), o9), gt(plus(o9, 155), o10)), and(gt(plus(o10_2, 224), o9_2), gt(plus(o9_2, 224), o10_2))), eq(plus(o9_3, 222), o10_3)))))))))));
    addConstraint(or(or(or(leq(plus(o2, 224), o6), leq(plus(o6, 224), o2)), or(leq(plus(o2_2, 224), o6_2), leq(plus(o6_2, 224), o2_2))), geq(plus(o6_3, 111), o2_3)));
    addConstraint(neq(plus(o6_3, 111), o2_3));
    addConstraint(or(or(or(leq(plus(o2, 224), o7), leq(plus(o7, 224), o2)), or(leq(plus(o2_2, 224), o7_2), leq(plus(o7_2, 224), o2_2))), geq(plus(o7_3, 111), o2_3)));
    addConstraint(neq(plus(o7_3, 111), o2_3));
    addConstraint(or(or(or(leq(plus(o2, 224), o10), leq(plus(o10, 112), o2)), or(leq(plus(o2_2, 224), o10_2), leq(plus(o10_2, 224), o2_2))), geq(plus(o10_3, 148), o2_3)));
    addConstraint(neq(plus(o10_3, 148), o2_3));
    addConstraint(or(or(or(leq(plus(o3, 224), o2), leq(plus(o2, 224), o3)), or(leq(plus(o3_2, 224), o2_2), leq(plus(o2_2, 224), o3_2))), geq(plus(o2_3, 111), o3_3)));
    addConstraint(neq(plus(o2_3, 111), o3_3));
    addConstraint(or(or(or(leq(plus(o3, 224), o5), leq(plus(o5, 224), o3)), or(leq(plus(o3_2, 224), o5_2), leq(plus(o5_2, 224), o3_2))), geq(plus(o5_3, 148), o3_3)));
    addConstraint(neq(plus(o5_3, 148), o3_3));
    addConstraint(or(or(or(leq(plus(o3, 224), o6), leq(plus(o6, 224), o3)), or(leq(plus(o3_2, 224), o6_2), leq(plus(o6_2, 224), o3_2))), geq(plus(o6_3, 111), o3_3)));
    addConstraint(neq(plus(o6_3, 111), o3_3));
    addConstraint(or(or(or(leq(plus(o3, 224), o7), leq(plus(o7, 224), o3)), or(leq(plus(o3_2, 224), o7_2), leq(plus(o7_2, 224), o3_2))), geq(plus(o7_3, 111), o3_3)));
    addConstraint(neq(plus(o7_3, 111), o3_3));
    addConstraint(or(or(or(leq(plus(o3, 224), o9), leq(plus(o9, 155), o3)), or(leq(plus(o3_2, 224), o9_2), leq(plus(o9_2, 224), o3_2))), geq(plus(o9_3, 222), o3_3)));
    addConstraint(neq(plus(o9_3, 222), o3_3));
    addConstraint(or(or(or(leq(plus(o3, 224), o10), leq(plus(o10, 112), o3)), or(leq(plus(o3_2, 224), o10_2), leq(plus(o10_2, 224), o3_2))), geq(plus(o10_3, 148), o3_3)));
    addConstraint(neq(plus(o10_3, 148), o3_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o2), leq(plus(o2, 224), o4)), or(leq(plus(o4_2, 224), o2_2), leq(plus(o2_2, 224), o4_2))), geq(plus(o2_3, 111), o4_3)));
    addConstraint(neq(plus(o2_3, 111), o4_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o3), leq(plus(o3, 224), o4)), or(leq(plus(o4_2, 224), o3_2), leq(plus(o3_2, 224), o4_2))), geq(plus(o3_3, 74), o4_3)));
    addConstraint(neq(plus(o3_3, 74), o4_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o5), leq(plus(o5, 224), o4)), or(leq(plus(o4_2, 224), o5_2), leq(plus(o5_2, 224), o4_2))), geq(plus(o5_3, 148), o4_3)));
    addConstraint(neq(plus(o5_3, 148), o4_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o6), leq(plus(o6, 224), o4)), or(leq(plus(o4_2, 224), o6_2), leq(plus(o6_2, 224), o4_2))), geq(plus(o6_3, 111), o4_3)));
    addConstraint(neq(plus(o6_3, 111), o4_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o7), leq(plus(o7, 224), o4)), or(leq(plus(o4_2, 224), o7_2), leq(plus(o7_2, 224), o4_2))), geq(plus(o7_3, 111), o4_3)));
    addConstraint(neq(plus(o7_3, 111), o4_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o8), leq(plus(o8, 224), o4)), or(leq(plus(o4_2, 224), o8_2), leq(plus(o8_2, 224), o4_2))), geq(plus(o8_3, 222), o4_3)));
    addConstraint(neq(plus(o8_3, 222), o4_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o9), leq(plus(o9, 155), o4)), or(leq(plus(o4_2, 224), o9_2), leq(plus(o9_2, 224), o4_2))), geq(plus(o9_3, 222), o4_3)));
    addConstraint(neq(plus(o9_3, 222), o4_3));
    addConstraint(or(or(or(leq(plus(o4, 224), o10), leq(plus(o10, 112), o4)), or(leq(plus(o4_2, 224), o10_2), leq(plus(o10_2, 224), o4_2))), geq(plus(o10_3, 148), o4_3)));
    addConstraint(neq(plus(o10_3, 148), o4_3));
    addConstraint(or(or(or(leq(plus(o5, 224), o2), leq(plus(o2, 224), o5)), or(leq(plus(o5_2, 224), o2_2), leq(plus(o2_2, 224), o5_2))), geq(plus(o2_3, 111), o5_3)));
    addConstraint(neq(plus(o2_3, 111), o5_3));
    addConstraint(or(or(or(leq(plus(o5, 224), o6), leq(plus(o6, 224), o5)), or(leq(plus(o5_2, 224), o6_2), leq(plus(o6_2, 224), o5_2))), geq(plus(o6_3, 111), o5_3)));
    addConstraint(neq(plus(o6_3, 111), o5_3));
    addConstraint(or(or(or(leq(plus(o5, 224), o7), leq(plus(o7, 224), o5)), or(leq(plus(o5_2, 224), o7_2), leq(plus(o7_2, 224), o5_2))), geq(plus(o7_3, 111), o5_3)));
    addConstraint(neq(plus(o7_3, 111), o5_3));
    addConstraint(or(or(or(leq(plus(o5, 224), o10), leq(plus(o10, 112), o5)), or(leq(plus(o5_2, 224), o10_2), leq(plus(o10_2, 224), o5_2))), geq(plus(o10_3, 148), o5_3)));
    addConstraint(neq(plus(o10_3, 148), o5_3));
    addConstraint(or(or(or(leq(plus(o7, 224), o6), leq(plus(o6, 224), o7)), or(leq(plus(o7_2, 224), o6_2), leq(plus(o6_2, 224), o7_2))), geq(plus(o6_3, 111), o7_3)));
    addConstraint(neq(plus(o6_3, 111), o7_3));
    addConstraint(or(or(or(leq(plus(o8, 224), o2), leq(plus(o2, 224), o8)), or(leq(plus(o8_2, 224), o2_2), leq(plus(o2_2, 224), o8_2))), geq(plus(o2_3, 111), o8_3)));
    addConstraint(neq(plus(o2_3, 111), o8_3));
    addConstraint(or(or(or(leq(plus(o8, 224), o3), leq(plus(o3, 224), o8)), or(leq(plus(o8_2, 224), o3_2), leq(plus(o3_2, 224), o8_2))), geq(plus(o3_3, 74), o8_3)));
    addConstraint(neq(plus(o3_3, 74), o8_3));
    addConstraint(or(or(or(leq(plus(o8, 224), o5), leq(plus(o5, 224), o8)), or(leq(plus(o8_2, 224), o5_2), leq(plus(o5_2, 224), o8_2))), geq(plus(o5_3, 148), o8_3)));
    addConstraint(neq(plus(o5_3, 148), o8_3));
    addConstraint(or(or(or(leq(plus(o8, 224), o6), leq(plus(o6, 224), o8)), or(leq(plus(o8_2, 224), o6_2), leq(plus(o6_2, 224), o8_2))), geq(plus(o6_3, 111), o8_3)));
    addConstraint(neq(plus(o6_3, 111), o8_3));
    addConstraint(or(or(or(leq(plus(o8, 224), o7), leq(plus(o7, 224), o8)), or(leq(plus(o8_2, 224), o7_2), leq(plus(o7_2, 224), o8_2))), geq(plus(o7_3, 111), o8_3)));
    addConstraint(neq(plus(o7_3, 111), o8_3));
    addConstraint(or(or(or(leq(plus(o8, 224), o9), leq(plus(o9, 155), o8)), or(leq(plus(o8_2, 224), o9_2), leq(plus(o9_2, 224), o8_2))), geq(plus(o9_3, 222), o8_3)));
    addConstraint(neq(plus(o9_3, 222), o8_3));
    addConstraint(or(or(or(leq(plus(o8, 224), o10), leq(plus(o10, 112), o8)), or(leq(plus(o8_2, 224), o10_2), leq(plus(o10_2, 224), o8_2))), geq(plus(o10_3, 148), o8_3)));
    addConstraint(neq(plus(o10_3, 148), o8_3));
    addConstraint(or(or(or(leq(plus(o9, 155), o2), leq(plus(o2, 224), o9)), or(leq(plus(o9_2, 224), o2_2), leq(plus(o2_2, 224), o9_2))), geq(plus(o2_3, 111), o9_3)));
    addConstraint(neq(plus(o2_3, 111), o9_3));
    addConstraint(or(or(or(leq(plus(o9, 155), o5), leq(plus(o5, 224), o9)), or(leq(plus(o9_2, 224), o5_2), leq(plus(o5_2, 224), o9_2))), geq(plus(o5_3, 148), o9_3)));
    addConstraint(neq(plus(o5_3, 148), o9_3));
    addConstraint(or(or(or(leq(plus(o9, 155), o6), leq(plus(o6, 224), o9)), or(leq(plus(o9_2, 224), o6_2), leq(plus(o6_2, 224), o9_2))), geq(plus(o6_3, 111), o9_3)));
    addConstraint(neq(plus(o6_3, 111), o9_3));
    addConstraint(or(or(or(leq(plus(o9, 155), o7), leq(plus(o7, 224), o9)), or(leq(plus(o9_2, 224), o7_2), leq(plus(o7_2, 224), o9_2))), geq(plus(o7_3, 111), o9_3)));
    addConstraint(neq(plus(o7_3, 111), o9_3));
    addConstraint(or(or(or(leq(plus(o9, 155), o10), leq(plus(o10, 112), o9)), or(leq(plus(o9_2, 224), o10_2), leq(plus(o10_2, 224), o9_2))), geq(plus(o10_3, 148), o9_3)));
    addConstraint(neq(plus(o10_3, 148), o9_3));
    addConstraint(or(or(or(leq(plus(o10, 112), o6), leq(plus(o6, 224), o10)), or(leq(plus(o10_2, 224), o6_2), leq(plus(o6_2, 224), o10_2))), geq(plus(o6_3, 111), o10_3)));
    addConstraint(neq(plus(o6_3, 111), o10_3));
    addConstraint(or(or(or(leq(plus(o10, 112), o7), leq(plus(o7, 224), o10)), or(leq(plus(o10_2, 224), o7_2), leq(plus(o7_2, 224), o10_2))), geq(plus(o7_3, 111), o10_3)));
    addConstraint(neq(plus(o7_3, 111), o10_3));
    addConstraint(leq(mult(100, max(plus(mult(413, reif_477), plus(mult(463, reif_478), plus(mult(842, reif_479), plus(mult(422, reif_480), plus(mult(266, reif_481), plus(mult(321, reif_482), plus(mult(670, reif_483), plus(mult(440, reif_484), mult(325, reif_485))))))))), plus(mult(413, reif_486), plus(mult(463, reif_487), plus(mult(842, reif_488), plus(mult(422, reif_489), plus(mult(266, reif_490), plus(mult(321, reif_491), plus(mult(670, reif_492), plus(mult(440, reif_493), mult(325, reif_494))))))))))), mult(120, min(plus(mult(413, reif_495), plus(mult(463, reif_496), plus(mult(842, reif_497), plus(mult(422, reif_498), plus(mult(266, reif_499), plus(mult(321, reif_500), plus(mult(670, reif_501), plus(mult(440, reif_502), mult(325, reif_503))))))))), plus(mult(413, reif_504), plus(mult(463, reif_505), plus(mult(842, reif_506), plus(mult(422, reif_507), plus(mult(266, reif_508), plus(mult(321, reif_509), plus(mult(670, reif_510), plus(mult(440, reif_511), mult(325, reif_512)))))))))))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o3), gt(plus(o3, 224), o2)), and(gt(plus(o2_2, 224), o3_2), gt(plus(o3_2, 224), o2_2))), and(leq(max(minus(max(o2, o3), min(o2, o3)), minus(max(plus(o2, 224), plus(o3, 224)), min(plus(o2, 224), plus(o3, 224)))), 10), leq(max(minus(max(o2_2, o3_2), min(o2_2, o3_2)), minus(max(plus(o2_2, 224), plus(o3_2, 224)), min(plus(o2_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o4), gt(plus(o4, 224), o2)), and(gt(plus(o2_2, 224), o4_2), gt(plus(o4_2, 224), o2_2))), and(leq(max(minus(max(o2, o4), min(o2, o4)), minus(max(plus(o2, 224), plus(o4, 224)), min(plus(o2, 224), plus(o4, 224)))), 10), leq(max(minus(max(o2_2, o4_2), min(o2_2, o4_2)), minus(max(plus(o2_2, 224), plus(o4_2, 224)), min(plus(o2_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o5), gt(plus(o5, 224), o2)), and(gt(plus(o2_2, 224), o5_2), gt(plus(o5_2, 224), o2_2))), and(leq(max(minus(max(o2, o5), min(o2, o5)), minus(max(plus(o2, 224), plus(o5, 224)), min(plus(o2, 224), plus(o5, 224)))), 10), leq(max(minus(max(o2_2, o5_2), min(o2_2, o5_2)), minus(max(plus(o2_2, 224), plus(o5_2, 224)), min(plus(o2_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o6), gt(plus(o6, 224), o2)), and(gt(plus(o2_2, 224), o6_2), gt(plus(o6_2, 224), o2_2))), and(leq(max(minus(max(o2, o6), min(o2, o6)), minus(max(plus(o2, 224), plus(o6, 224)), min(plus(o2, 224), plus(o6, 224)))), 10), leq(max(minus(max(o2_2, o6_2), min(o2_2, o6_2)), minus(max(plus(o2_2, 224), plus(o6_2, 224)), min(plus(o2_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o7), gt(plus(o7, 224), o2)), and(gt(plus(o2_2, 224), o7_2), gt(plus(o7_2, 224), o2_2))), and(leq(max(minus(max(o2, o7), min(o2, o7)), minus(max(plus(o2, 224), plus(o7, 224)), min(plus(o2, 224), plus(o7, 224)))), 10), leq(max(minus(max(o2_2, o7_2), min(o2_2, o7_2)), minus(max(plus(o2_2, 224), plus(o7_2, 224)), min(plus(o2_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o8), gt(plus(o8, 224), o2)), and(gt(plus(o2_2, 224), o8_2), gt(plus(o8_2, 224), o2_2))), and(leq(max(minus(max(o2, o8), min(o2, o8)), minus(max(plus(o2, 224), plus(o8, 224)), min(plus(o2, 224), plus(o8, 224)))), 10), leq(max(minus(max(o2_2, o8_2), min(o2_2, o8_2)), minus(max(plus(o2_2, 224), plus(o8_2, 224)), min(plus(o2_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o9), gt(plus(o9, 155), o2)), and(gt(plus(o2_2, 224), o9_2), gt(plus(o9_2, 224), o2_2))), and(leq(max(minus(max(o2, o9), min(o2, o9)), minus(max(plus(o2, 224), plus(o9, 155)), min(plus(o2, 224), plus(o9, 155)))), 10), leq(max(minus(max(o2_2, o9_2), min(o2_2, o9_2)), minus(max(plus(o2_2, 224), plus(o9_2, 224)), min(plus(o2_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o2, 224), o10), gt(plus(o10, 112), o2)), and(gt(plus(o2_2, 224), o10_2), gt(plus(o10_2, 224), o2_2))), and(leq(max(minus(max(o2, o10), min(o2, o10)), minus(max(plus(o2, 224), plus(o10, 112)), min(plus(o2, 224), plus(o10, 112)))), 10), leq(max(minus(max(o2_2, o10_2), min(o2_2, o10_2)), minus(max(plus(o2_2, 224), plus(o10_2, 224)), min(plus(o2_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o2), gt(plus(o2, 224), o3)), and(gt(plus(o3_2, 224), o2_2), gt(plus(o2_2, 224), o3_2))), and(leq(max(minus(max(o3, o2), min(o3, o2)), minus(max(plus(o3, 224), plus(o2, 224)), min(plus(o3, 224), plus(o2, 224)))), 10), leq(max(minus(max(o3_2, o2_2), min(o3_2, o2_2)), minus(max(plus(o3_2, 224), plus(o2_2, 224)), min(plus(o3_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o4), gt(plus(o4, 224), o3)), and(gt(plus(o3_2, 224), o4_2), gt(plus(o4_2, 224), o3_2))), and(leq(max(minus(max(o3, o4), min(o3, o4)), minus(max(plus(o3, 224), plus(o4, 224)), min(plus(o3, 224), plus(o4, 224)))), 10), leq(max(minus(max(o3_2, o4_2), min(o3_2, o4_2)), minus(max(plus(o3_2, 224), plus(o4_2, 224)), min(plus(o3_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o5), gt(plus(o5, 224), o3)), and(gt(plus(o3_2, 224), o5_2), gt(plus(o5_2, 224), o3_2))), and(leq(max(minus(max(o3, o5), min(o3, o5)), minus(max(plus(o3, 224), plus(o5, 224)), min(plus(o3, 224), plus(o5, 224)))), 10), leq(max(minus(max(o3_2, o5_2), min(o3_2, o5_2)), minus(max(plus(o3_2, 224), plus(o5_2, 224)), min(plus(o3_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o6), gt(plus(o6, 224), o3)), and(gt(plus(o3_2, 224), o6_2), gt(plus(o6_2, 224), o3_2))), and(leq(max(minus(max(o3, o6), min(o3, o6)), minus(max(plus(o3, 224), plus(o6, 224)), min(plus(o3, 224), plus(o6, 224)))), 10), leq(max(minus(max(o3_2, o6_2), min(o3_2, o6_2)), minus(max(plus(o3_2, 224), plus(o6_2, 224)), min(plus(o3_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o7), gt(plus(o7, 224), o3)), and(gt(plus(o3_2, 224), o7_2), gt(plus(o7_2, 224), o3_2))), and(leq(max(minus(max(o3, o7), min(o3, o7)), minus(max(plus(o3, 224), plus(o7, 224)), min(plus(o3, 224), plus(o7, 224)))), 10), leq(max(minus(max(o3_2, o7_2), min(o3_2, o7_2)), minus(max(plus(o3_2, 224), plus(o7_2, 224)), min(plus(o3_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o8), gt(plus(o8, 224), o3)), and(gt(plus(o3_2, 224), o8_2), gt(plus(o8_2, 224), o3_2))), and(leq(max(minus(max(o3, o8), min(o3, o8)), minus(max(plus(o3, 224), plus(o8, 224)), min(plus(o3, 224), plus(o8, 224)))), 10), leq(max(minus(max(o3_2, o8_2), min(o3_2, o8_2)), minus(max(plus(o3_2, 224), plus(o8_2, 224)), min(plus(o3_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o9), gt(plus(o9, 155), o3)), and(gt(plus(o3_2, 224), o9_2), gt(plus(o9_2, 224), o3_2))), and(leq(max(minus(max(o3, o9), min(o3, o9)), minus(max(plus(o3, 224), plus(o9, 155)), min(plus(o3, 224), plus(o9, 155)))), 10), leq(max(minus(max(o3_2, o9_2), min(o3_2, o9_2)), minus(max(plus(o3_2, 224), plus(o9_2, 224)), min(plus(o3_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o3, 224), o10), gt(plus(o10, 112), o3)), and(gt(plus(o3_2, 224), o10_2), gt(plus(o10_2, 224), o3_2))), and(leq(max(minus(max(o3, o10), min(o3, o10)), minus(max(plus(o3, 224), plus(o10, 112)), min(plus(o3, 224), plus(o10, 112)))), 10), leq(max(minus(max(o3_2, o10_2), min(o3_2, o10_2)), minus(max(plus(o3_2, 224), plus(o10_2, 224)), min(plus(o3_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o2), gt(plus(o2, 224), o4)), and(gt(plus(o4_2, 224), o2_2), gt(plus(o2_2, 224), o4_2))), and(leq(max(minus(max(o4, o2), min(o4, o2)), minus(max(plus(o4, 224), plus(o2, 224)), min(plus(o4, 224), plus(o2, 224)))), 10), leq(max(minus(max(o4_2, o2_2), min(o4_2, o2_2)), minus(max(plus(o4_2, 224), plus(o2_2, 224)), min(plus(o4_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o3), gt(plus(o3, 224), o4)), and(gt(plus(o4_2, 224), o3_2), gt(plus(o3_2, 224), o4_2))), and(leq(max(minus(max(o4, o3), min(o4, o3)), minus(max(plus(o4, 224), plus(o3, 224)), min(plus(o4, 224), plus(o3, 224)))), 10), leq(max(minus(max(o4_2, o3_2), min(o4_2, o3_2)), minus(max(plus(o4_2, 224), plus(o3_2, 224)), min(plus(o4_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o5), gt(plus(o5, 224), o4)), and(gt(plus(o4_2, 224), o5_2), gt(plus(o5_2, 224), o4_2))), and(leq(max(minus(max(o4, o5), min(o4, o5)), minus(max(plus(o4, 224), plus(o5, 224)), min(plus(o4, 224), plus(o5, 224)))), 10), leq(max(minus(max(o4_2, o5_2), min(o4_2, o5_2)), minus(max(plus(o4_2, 224), plus(o5_2, 224)), min(plus(o4_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o6), gt(plus(o6, 224), o4)), and(gt(plus(o4_2, 224), o6_2), gt(plus(o6_2, 224), o4_2))), and(leq(max(minus(max(o4, o6), min(o4, o6)), minus(max(plus(o4, 224), plus(o6, 224)), min(plus(o4, 224), plus(o6, 224)))), 10), leq(max(minus(max(o4_2, o6_2), min(o4_2, o6_2)), minus(max(plus(o4_2, 224), plus(o6_2, 224)), min(plus(o4_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o7), gt(plus(o7, 224), o4)), and(gt(plus(o4_2, 224), o7_2), gt(plus(o7_2, 224), o4_2))), and(leq(max(minus(max(o4, o7), min(o4, o7)), minus(max(plus(o4, 224), plus(o7, 224)), min(plus(o4, 224), plus(o7, 224)))), 10), leq(max(minus(max(o4_2, o7_2), min(o4_2, o7_2)), minus(max(plus(o4_2, 224), plus(o7_2, 224)), min(plus(o4_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o8), gt(plus(o8, 224), o4)), and(gt(plus(o4_2, 224), o8_2), gt(plus(o8_2, 224), o4_2))), and(leq(max(minus(max(o4, o8), min(o4, o8)), minus(max(plus(o4, 224), plus(o8, 224)), min(plus(o4, 224), plus(o8, 224)))), 10), leq(max(minus(max(o4_2, o8_2), min(o4_2, o8_2)), minus(max(plus(o4_2, 224), plus(o8_2, 224)), min(plus(o4_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o9), gt(plus(o9, 155), o4)), and(gt(plus(o4_2, 224), o9_2), gt(plus(o9_2, 224), o4_2))), and(leq(max(minus(max(o4, o9), min(o4, o9)), minus(max(plus(o4, 224), plus(o9, 155)), min(plus(o4, 224), plus(o9, 155)))), 10), leq(max(minus(max(o4_2, o9_2), min(o4_2, o9_2)), minus(max(plus(o4_2, 224), plus(o9_2, 224)), min(plus(o4_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o4, 224), o10), gt(plus(o10, 112), o4)), and(gt(plus(o4_2, 224), o10_2), gt(plus(o10_2, 224), o4_2))), and(leq(max(minus(max(o4, o10), min(o4, o10)), minus(max(plus(o4, 224), plus(o10, 112)), min(plus(o4, 224), plus(o10, 112)))), 10), leq(max(minus(max(o4_2, o10_2), min(o4_2, o10_2)), minus(max(plus(o4_2, 224), plus(o10_2, 224)), min(plus(o4_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o2), gt(plus(o2, 224), o5)), and(gt(plus(o5_2, 224), o2_2), gt(plus(o2_2, 224), o5_2))), and(leq(max(minus(max(o5, o2), min(o5, o2)), minus(max(plus(o5, 224), plus(o2, 224)), min(plus(o5, 224), plus(o2, 224)))), 10), leq(max(minus(max(o5_2, o2_2), min(o5_2, o2_2)), minus(max(plus(o5_2, 224), plus(o2_2, 224)), min(plus(o5_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o3), gt(plus(o3, 224), o5)), and(gt(plus(o5_2, 224), o3_2), gt(plus(o3_2, 224), o5_2))), and(leq(max(minus(max(o5, o3), min(o5, o3)), minus(max(plus(o5, 224), plus(o3, 224)), min(plus(o5, 224), plus(o3, 224)))), 10), leq(max(minus(max(o5_2, o3_2), min(o5_2, o3_2)), minus(max(plus(o5_2, 224), plus(o3_2, 224)), min(plus(o5_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o4), gt(plus(o4, 224), o5)), and(gt(plus(o5_2, 224), o4_2), gt(plus(o4_2, 224), o5_2))), and(leq(max(minus(max(o5, o4), min(o5, o4)), minus(max(plus(o5, 224), plus(o4, 224)), min(plus(o5, 224), plus(o4, 224)))), 10), leq(max(minus(max(o5_2, o4_2), min(o5_2, o4_2)), minus(max(plus(o5_2, 224), plus(o4_2, 224)), min(plus(o5_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o6), gt(plus(o6, 224), o5)), and(gt(plus(o5_2, 224), o6_2), gt(plus(o6_2, 224), o5_2))), and(leq(max(minus(max(o5, o6), min(o5, o6)), minus(max(plus(o5, 224), plus(o6, 224)), min(plus(o5, 224), plus(o6, 224)))), 10), leq(max(minus(max(o5_2, o6_2), min(o5_2, o6_2)), minus(max(plus(o5_2, 224), plus(o6_2, 224)), min(plus(o5_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o7), gt(plus(o7, 224), o5)), and(gt(plus(o5_2, 224), o7_2), gt(plus(o7_2, 224), o5_2))), and(leq(max(minus(max(o5, o7), min(o5, o7)), minus(max(plus(o5, 224), plus(o7, 224)), min(plus(o5, 224), plus(o7, 224)))), 10), leq(max(minus(max(o5_2, o7_2), min(o5_2, o7_2)), minus(max(plus(o5_2, 224), plus(o7_2, 224)), min(plus(o5_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o8), gt(plus(o8, 224), o5)), and(gt(plus(o5_2, 224), o8_2), gt(plus(o8_2, 224), o5_2))), and(leq(max(minus(max(o5, o8), min(o5, o8)), minus(max(plus(o5, 224), plus(o8, 224)), min(plus(o5, 224), plus(o8, 224)))), 10), leq(max(minus(max(o5_2, o8_2), min(o5_2, o8_2)), minus(max(plus(o5_2, 224), plus(o8_2, 224)), min(plus(o5_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o9), gt(plus(o9, 155), o5)), and(gt(plus(o5_2, 224), o9_2), gt(plus(o9_2, 224), o5_2))), and(leq(max(minus(max(o5, o9), min(o5, o9)), minus(max(plus(o5, 224), plus(o9, 155)), min(plus(o5, 224), plus(o9, 155)))), 10), leq(max(minus(max(o5_2, o9_2), min(o5_2, o9_2)), minus(max(plus(o5_2, 224), plus(o9_2, 224)), min(plus(o5_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o5, 224), o10), gt(plus(o10, 112), o5)), and(gt(plus(o5_2, 224), o10_2), gt(plus(o10_2, 224), o5_2))), and(leq(max(minus(max(o5, o10), min(o5, o10)), minus(max(plus(o5, 224), plus(o10, 112)), min(plus(o5, 224), plus(o10, 112)))), 10), leq(max(minus(max(o5_2, o10_2), min(o5_2, o10_2)), minus(max(plus(o5_2, 224), plus(o10_2, 224)), min(plus(o5_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o2), gt(plus(o2, 224), o6)), and(gt(plus(o6_2, 224), o2_2), gt(plus(o2_2, 224), o6_2))), and(leq(max(minus(max(o6, o2), min(o6, o2)), minus(max(plus(o6, 224), plus(o2, 224)), min(plus(o6, 224), plus(o2, 224)))), 10), leq(max(minus(max(o6_2, o2_2), min(o6_2, o2_2)), minus(max(plus(o6_2, 224), plus(o2_2, 224)), min(plus(o6_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o3), gt(plus(o3, 224), o6)), and(gt(plus(o6_2, 224), o3_2), gt(plus(o3_2, 224), o6_2))), and(leq(max(minus(max(o6, o3), min(o6, o3)), minus(max(plus(o6, 224), plus(o3, 224)), min(plus(o6, 224), plus(o3, 224)))), 10), leq(max(minus(max(o6_2, o3_2), min(o6_2, o3_2)), minus(max(plus(o6_2, 224), plus(o3_2, 224)), min(plus(o6_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o4), gt(plus(o4, 224), o6)), and(gt(plus(o6_2, 224), o4_2), gt(plus(o4_2, 224), o6_2))), and(leq(max(minus(max(o6, o4), min(o6, o4)), minus(max(plus(o6, 224), plus(o4, 224)), min(plus(o6, 224), plus(o4, 224)))), 10), leq(max(minus(max(o6_2, o4_2), min(o6_2, o4_2)), minus(max(plus(o6_2, 224), plus(o4_2, 224)), min(plus(o6_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o5), gt(plus(o5, 224), o6)), and(gt(plus(o6_2, 224), o5_2), gt(plus(o5_2, 224), o6_2))), and(leq(max(minus(max(o6, o5), min(o6, o5)), minus(max(plus(o6, 224), plus(o5, 224)), min(plus(o6, 224), plus(o5, 224)))), 10), leq(max(minus(max(o6_2, o5_2), min(o6_2, o5_2)), minus(max(plus(o6_2, 224), plus(o5_2, 224)), min(plus(o6_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o7), gt(plus(o7, 224), o6)), and(gt(plus(o6_2, 224), o7_2), gt(plus(o7_2, 224), o6_2))), and(leq(max(minus(max(o6, o7), min(o6, o7)), minus(max(plus(o6, 224), plus(o7, 224)), min(plus(o6, 224), plus(o7, 224)))), 10), leq(max(minus(max(o6_2, o7_2), min(o6_2, o7_2)), minus(max(plus(o6_2, 224), plus(o7_2, 224)), min(plus(o6_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o8), gt(plus(o8, 224), o6)), and(gt(plus(o6_2, 224), o8_2), gt(plus(o8_2, 224), o6_2))), and(leq(max(minus(max(o6, o8), min(o6, o8)), minus(max(plus(o6, 224), plus(o8, 224)), min(plus(o6, 224), plus(o8, 224)))), 10), leq(max(minus(max(o6_2, o8_2), min(o6_2, o8_2)), minus(max(plus(o6_2, 224), plus(o8_2, 224)), min(plus(o6_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o9), gt(plus(o9, 155), o6)), and(gt(plus(o6_2, 224), o9_2), gt(plus(o9_2, 224), o6_2))), and(leq(max(minus(max(o6, o9), min(o6, o9)), minus(max(plus(o6, 224), plus(o9, 155)), min(plus(o6, 224), plus(o9, 155)))), 10), leq(max(minus(max(o6_2, o9_2), min(o6_2, o9_2)), minus(max(plus(o6_2, 224), plus(o9_2, 224)), min(plus(o6_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o6, 224), o10), gt(plus(o10, 112), o6)), and(gt(plus(o6_2, 224), o10_2), gt(plus(o10_2, 224), o6_2))), and(leq(max(minus(max(o6, o10), min(o6, o10)), minus(max(plus(o6, 224), plus(o10, 112)), min(plus(o6, 224), plus(o10, 112)))), 10), leq(max(minus(max(o6_2, o10_2), min(o6_2, o10_2)), minus(max(plus(o6_2, 224), plus(o10_2, 224)), min(plus(o6_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o2), gt(plus(o2, 224), o7)), and(gt(plus(o7_2, 224), o2_2), gt(plus(o2_2, 224), o7_2))), and(leq(max(minus(max(o7, o2), min(o7, o2)), minus(max(plus(o7, 224), plus(o2, 224)), min(plus(o7, 224), plus(o2, 224)))), 10), leq(max(minus(max(o7_2, o2_2), min(o7_2, o2_2)), minus(max(plus(o7_2, 224), plus(o2_2, 224)), min(plus(o7_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o3), gt(plus(o3, 224), o7)), and(gt(plus(o7_2, 224), o3_2), gt(plus(o3_2, 224), o7_2))), and(leq(max(minus(max(o7, o3), min(o7, o3)), minus(max(plus(o7, 224), plus(o3, 224)), min(plus(o7, 224), plus(o3, 224)))), 10), leq(max(minus(max(o7_2, o3_2), min(o7_2, o3_2)), minus(max(plus(o7_2, 224), plus(o3_2, 224)), min(plus(o7_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o4), gt(plus(o4, 224), o7)), and(gt(plus(o7_2, 224), o4_2), gt(plus(o4_2, 224), o7_2))), and(leq(max(minus(max(o7, o4), min(o7, o4)), minus(max(plus(o7, 224), plus(o4, 224)), min(plus(o7, 224), plus(o4, 224)))), 10), leq(max(minus(max(o7_2, o4_2), min(o7_2, o4_2)), minus(max(plus(o7_2, 224), plus(o4_2, 224)), min(plus(o7_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o5), gt(plus(o5, 224), o7)), and(gt(plus(o7_2, 224), o5_2), gt(plus(o5_2, 224), o7_2))), and(leq(max(minus(max(o7, o5), min(o7, o5)), minus(max(plus(o7, 224), plus(o5, 224)), min(plus(o7, 224), plus(o5, 224)))), 10), leq(max(minus(max(o7_2, o5_2), min(o7_2, o5_2)), minus(max(plus(o7_2, 224), plus(o5_2, 224)), min(plus(o7_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o6), gt(plus(o6, 224), o7)), and(gt(plus(o7_2, 224), o6_2), gt(plus(o6_2, 224), o7_2))), and(leq(max(minus(max(o7, o6), min(o7, o6)), minus(max(plus(o7, 224), plus(o6, 224)), min(plus(o7, 224), plus(o6, 224)))), 10), leq(max(minus(max(o7_2, o6_2), min(o7_2, o6_2)), minus(max(plus(o7_2, 224), plus(o6_2, 224)), min(plus(o7_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o8), gt(plus(o8, 224), o7)), and(gt(plus(o7_2, 224), o8_2), gt(plus(o8_2, 224), o7_2))), and(leq(max(minus(max(o7, o8), min(o7, o8)), minus(max(plus(o7, 224), plus(o8, 224)), min(plus(o7, 224), plus(o8, 224)))), 10), leq(max(minus(max(o7_2, o8_2), min(o7_2, o8_2)), minus(max(plus(o7_2, 224), plus(o8_2, 224)), min(plus(o7_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o9), gt(plus(o9, 155), o7)), and(gt(plus(o7_2, 224), o9_2), gt(plus(o9_2, 224), o7_2))), and(leq(max(minus(max(o7, o9), min(o7, o9)), minus(max(plus(o7, 224), plus(o9, 155)), min(plus(o7, 224), plus(o9, 155)))), 10), leq(max(minus(max(o7_2, o9_2), min(o7_2, o9_2)), minus(max(plus(o7_2, 224), plus(o9_2, 224)), min(plus(o7_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o7, 224), o10), gt(plus(o10, 112), o7)), and(gt(plus(o7_2, 224), o10_2), gt(plus(o10_2, 224), o7_2))), and(leq(max(minus(max(o7, o10), min(o7, o10)), minus(max(plus(o7, 224), plus(o10, 112)), min(plus(o7, 224), plus(o10, 112)))), 10), leq(max(minus(max(o7_2, o10_2), min(o7_2, o10_2)), minus(max(plus(o7_2, 224), plus(o10_2, 224)), min(plus(o7_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o2), gt(plus(o2, 224), o8)), and(gt(plus(o8_2, 224), o2_2), gt(plus(o2_2, 224), o8_2))), and(leq(max(minus(max(o8, o2), min(o8, o2)), minus(max(plus(o8, 224), plus(o2, 224)), min(plus(o8, 224), plus(o2, 224)))), 10), leq(max(minus(max(o8_2, o2_2), min(o8_2, o2_2)), minus(max(plus(o8_2, 224), plus(o2_2, 224)), min(plus(o8_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o3), gt(plus(o3, 224), o8)), and(gt(plus(o8_2, 224), o3_2), gt(plus(o3_2, 224), o8_2))), and(leq(max(minus(max(o8, o3), min(o8, o3)), minus(max(plus(o8, 224), plus(o3, 224)), min(plus(o8, 224), plus(o3, 224)))), 10), leq(max(minus(max(o8_2, o3_2), min(o8_2, o3_2)), minus(max(plus(o8_2, 224), plus(o3_2, 224)), min(plus(o8_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o4), gt(plus(o4, 224), o8)), and(gt(plus(o8_2, 224), o4_2), gt(plus(o4_2, 224), o8_2))), and(leq(max(minus(max(o8, o4), min(o8, o4)), minus(max(plus(o8, 224), plus(o4, 224)), min(plus(o8, 224), plus(o4, 224)))), 10), leq(max(minus(max(o8_2, o4_2), min(o8_2, o4_2)), minus(max(plus(o8_2, 224), plus(o4_2, 224)), min(plus(o8_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o5), gt(plus(o5, 224), o8)), and(gt(plus(o8_2, 224), o5_2), gt(plus(o5_2, 224), o8_2))), and(leq(max(minus(max(o8, o5), min(o8, o5)), minus(max(plus(o8, 224), plus(o5, 224)), min(plus(o8, 224), plus(o5, 224)))), 10), leq(max(minus(max(o8_2, o5_2), min(o8_2, o5_2)), minus(max(plus(o8_2, 224), plus(o5_2, 224)), min(plus(o8_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o6), gt(plus(o6, 224), o8)), and(gt(plus(o8_2, 224), o6_2), gt(plus(o6_2, 224), o8_2))), and(leq(max(minus(max(o8, o6), min(o8, o6)), minus(max(plus(o8, 224), plus(o6, 224)), min(plus(o8, 224), plus(o6, 224)))), 10), leq(max(minus(max(o8_2, o6_2), min(o8_2, o6_2)), minus(max(plus(o8_2, 224), plus(o6_2, 224)), min(plus(o8_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o7), gt(plus(o7, 224), o8)), and(gt(plus(o8_2, 224), o7_2), gt(plus(o7_2, 224), o8_2))), and(leq(max(minus(max(o8, o7), min(o8, o7)), minus(max(plus(o8, 224), plus(o7, 224)), min(plus(o8, 224), plus(o7, 224)))), 10), leq(max(minus(max(o8_2, o7_2), min(o8_2, o7_2)), minus(max(plus(o8_2, 224), plus(o7_2, 224)), min(plus(o8_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o9), gt(plus(o9, 155), o8)), and(gt(plus(o8_2, 224), o9_2), gt(plus(o9_2, 224), o8_2))), and(leq(max(minus(max(o8, o9), min(o8, o9)), minus(max(plus(o8, 224), plus(o9, 155)), min(plus(o8, 224), plus(o9, 155)))), 10), leq(max(minus(max(o8_2, o9_2), min(o8_2, o9_2)), minus(max(plus(o8_2, 224), plus(o9_2, 224)), min(plus(o8_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o8, 224), o10), gt(plus(o10, 112), o8)), and(gt(plus(o8_2, 224), o10_2), gt(plus(o10_2, 224), o8_2))), and(leq(max(minus(max(o8, o10), min(o8, o10)), minus(max(plus(o8, 224), plus(o10, 112)), min(plus(o8, 224), plus(o10, 112)))), 10), leq(max(minus(max(o8_2, o10_2), min(o8_2, o10_2)), minus(max(plus(o8_2, 224), plus(o10_2, 224)), min(plus(o8_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o2), gt(plus(o2, 224), o9)), and(gt(plus(o9_2, 224), o2_2), gt(plus(o2_2, 224), o9_2))), and(leq(max(minus(max(o9, o2), min(o9, o2)), minus(max(plus(o9, 155), plus(o2, 224)), min(plus(o9, 155), plus(o2, 224)))), 10), leq(max(minus(max(o9_2, o2_2), min(o9_2, o2_2)), minus(max(plus(o9_2, 224), plus(o2_2, 224)), min(plus(o9_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o3), gt(plus(o3, 224), o9)), and(gt(plus(o9_2, 224), o3_2), gt(plus(o3_2, 224), o9_2))), and(leq(max(minus(max(o9, o3), min(o9, o3)), minus(max(plus(o9, 155), plus(o3, 224)), min(plus(o9, 155), plus(o3, 224)))), 10), leq(max(minus(max(o9_2, o3_2), min(o9_2, o3_2)), minus(max(plus(o9_2, 224), plus(o3_2, 224)), min(plus(o9_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o4), gt(plus(o4, 224), o9)), and(gt(plus(o9_2, 224), o4_2), gt(plus(o4_2, 224), o9_2))), and(leq(max(minus(max(o9, o4), min(o9, o4)), minus(max(plus(o9, 155), plus(o4, 224)), min(plus(o9, 155), plus(o4, 224)))), 10), leq(max(minus(max(o9_2, o4_2), min(o9_2, o4_2)), minus(max(plus(o9_2, 224), plus(o4_2, 224)), min(plus(o9_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o5), gt(plus(o5, 224), o9)), and(gt(plus(o9_2, 224), o5_2), gt(plus(o5_2, 224), o9_2))), and(leq(max(minus(max(o9, o5), min(o9, o5)), minus(max(plus(o9, 155), plus(o5, 224)), min(plus(o9, 155), plus(o5, 224)))), 10), leq(max(minus(max(o9_2, o5_2), min(o9_2, o5_2)), minus(max(plus(o9_2, 224), plus(o5_2, 224)), min(plus(o9_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o6), gt(plus(o6, 224), o9)), and(gt(plus(o9_2, 224), o6_2), gt(plus(o6_2, 224), o9_2))), and(leq(max(minus(max(o9, o6), min(o9, o6)), minus(max(plus(o9, 155), plus(o6, 224)), min(plus(o9, 155), plus(o6, 224)))), 10), leq(max(minus(max(o9_2, o6_2), min(o9_2, o6_2)), minus(max(plus(o9_2, 224), plus(o6_2, 224)), min(plus(o9_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o7), gt(plus(o7, 224), o9)), and(gt(plus(o9_2, 224), o7_2), gt(plus(o7_2, 224), o9_2))), and(leq(max(minus(max(o9, o7), min(o9, o7)), minus(max(plus(o9, 155), plus(o7, 224)), min(plus(o9, 155), plus(o7, 224)))), 10), leq(max(minus(max(o9_2, o7_2), min(o9_2, o7_2)), minus(max(plus(o9_2, 224), plus(o7_2, 224)), min(plus(o9_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o8), gt(plus(o8, 224), o9)), and(gt(plus(o9_2, 224), o8_2), gt(plus(o8_2, 224), o9_2))), and(leq(max(minus(max(o9, o8), min(o9, o8)), minus(max(plus(o9, 155), plus(o8, 224)), min(plus(o9, 155), plus(o8, 224)))), 10), leq(max(minus(max(o9_2, o8_2), min(o9_2, o8_2)), minus(max(plus(o9_2, 224), plus(o8_2, 224)), min(plus(o9_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o9, 155), o10), gt(plus(o10, 112), o9)), and(gt(plus(o9_2, 224), o10_2), gt(plus(o10_2, 224), o9_2))), and(leq(max(minus(max(o9, o10), min(o9, o10)), minus(max(plus(o9, 155), plus(o10, 112)), min(plus(o9, 155), plus(o10, 112)))), 10), leq(max(minus(max(o9_2, o10_2), min(o9_2, o10_2)), minus(max(plus(o9_2, 224), plus(o10_2, 224)), min(plus(o9_2, 224), plus(o10_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o2), gt(plus(o2, 224), o10)), and(gt(plus(o10_2, 224), o2_2), gt(plus(o2_2, 224), o10_2))), and(leq(max(minus(max(o10, o2), min(o10, o2)), minus(max(plus(o10, 112), plus(o2, 224)), min(plus(o10, 112), plus(o2, 224)))), 10), leq(max(minus(max(o10_2, o2_2), min(o10_2, o2_2)), minus(max(plus(o10_2, 224), plus(o2_2, 224)), min(plus(o10_2, 224), plus(o2_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o3), gt(plus(o3, 224), o10)), and(gt(plus(o10_2, 224), o3_2), gt(plus(o3_2, 224), o10_2))), and(leq(max(minus(max(o10, o3), min(o10, o3)), minus(max(plus(o10, 112), plus(o3, 224)), min(plus(o10, 112), plus(o3, 224)))), 10), leq(max(minus(max(o10_2, o3_2), min(o10_2, o3_2)), minus(max(plus(o10_2, 224), plus(o3_2, 224)), min(plus(o10_2, 224), plus(o3_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o4), gt(plus(o4, 224), o10)), and(gt(plus(o10_2, 224), o4_2), gt(plus(o4_2, 224), o10_2))), and(leq(max(minus(max(o10, o4), min(o10, o4)), minus(max(plus(o10, 112), plus(o4, 224)), min(plus(o10, 112), plus(o4, 224)))), 10), leq(max(minus(max(o10_2, o4_2), min(o10_2, o4_2)), minus(max(plus(o10_2, 224), plus(o4_2, 224)), min(plus(o10_2, 224), plus(o4_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o5), gt(plus(o5, 224), o10)), and(gt(plus(o10_2, 224), o5_2), gt(plus(o5_2, 224), o10_2))), and(leq(max(minus(max(o10, o5), min(o10, o5)), minus(max(plus(o10, 112), plus(o5, 224)), min(plus(o10, 112), plus(o5, 224)))), 10), leq(max(minus(max(o10_2, o5_2), min(o10_2, o5_2)), minus(max(plus(o10_2, 224), plus(o5_2, 224)), min(plus(o10_2, 224), plus(o5_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o6), gt(plus(o6, 224), o10)), and(gt(plus(o10_2, 224), o6_2), gt(plus(o6_2, 224), o10_2))), and(leq(max(minus(max(o10, o6), min(o10, o6)), minus(max(plus(o10, 112), plus(o6, 224)), min(plus(o10, 112), plus(o6, 224)))), 10), leq(max(minus(max(o10_2, o6_2), min(o10_2, o6_2)), minus(max(plus(o10_2, 224), plus(o6_2, 224)), min(plus(o10_2, 224), plus(o6_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o7), gt(plus(o7, 224), o10)), and(gt(plus(o10_2, 224), o7_2), gt(plus(o7_2, 224), o10_2))), and(leq(max(minus(max(o10, o7), min(o10, o7)), minus(max(plus(o10, 112), plus(o7, 224)), min(plus(o10, 112), plus(o7, 224)))), 10), leq(max(minus(max(o10_2, o7_2), min(o10_2, o7_2)), minus(max(plus(o10_2, 224), plus(o7_2, 224)), min(plus(o10_2, 224), plus(o7_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o8), gt(plus(o8, 224), o10)), and(gt(plus(o10_2, 224), o8_2), gt(plus(o8_2, 224), o10_2))), and(leq(max(minus(max(o10, o8), min(o10, o8)), minus(max(plus(o10, 112), plus(o8, 224)), min(plus(o10, 112), plus(o8, 224)))), 10), leq(max(minus(max(o10_2, o8_2), min(o10_2, o8_2)), minus(max(plus(o10_2, 224), plus(o8_2, 224)), min(plus(o10_2, 224), plus(o8_2, 224)))), 10))));
    addConstraint(implies(and(and(gt(plus(o10, 112), o9), gt(plus(o9, 155), o10)), and(gt(plus(o10_2, 224), o9_2), gt(plus(o9_2, 224), o10_2))), and(leq(max(minus(max(o10, o9), min(o10, o9)), minus(max(plus(o10, 112), plus(o9, 155)), min(plus(o10, 112), plus(o9, 155)))), 10), leq(max(minus(max(o10_2, o9_2), min(o10_2, o9_2)), minus(max(plus(o10_2, 224), plus(o9_2, 224)), min(plus(o10_2, 224), plus(o9_2, 224)))), 10))));
    addConstraint(leq(0, o2));
    addConstraint(leq(plus(o2, 224), 1203));
    addConstraint(leq(0, o2_2));
    addConstraint(leq(plus(o2_2, 224), 235));
    addConstraint(leq(0, o2_3));
    addConstraint(leq(plus(o2_3, 111), 239));
    addConstraint(leq(0, o3));
    addConstraint(leq(plus(o3, 224), 1203));
    addConstraint(leq(0, o3_2));
    addConstraint(leq(plus(o3_2, 224), 235));
    addConstraint(leq(0, o3_3));
    addConstraint(leq(plus(o3_3, 74), 239));
    addConstraint(leq(0, o4));
    addConstraint(leq(plus(o4, 224), 1203));
    addConstraint(leq(0, o4_2));
    addConstraint(leq(plus(o4_2, 224), 235));
    addConstraint(leq(0, o4_3));
    addConstraint(leq(plus(o4_3, 74), 239));
    addConstraint(leq(0, o5));
    addConstraint(leq(plus(o5, 224), 1203));
    addConstraint(leq(0, o5_2));
    addConstraint(leq(plus(o5_2, 224), 235));
    addConstraint(leq(0, o5_3));
    addConstraint(leq(plus(o5_3, 148), 239));
    addConstraint(leq(0, o6));
    addConstraint(leq(plus(o6, 224), 1203));
    addConstraint(leq(0, o6_2));
    addConstraint(leq(plus(o6_2, 224), 235));
    addConstraint(leq(0, o6_3));
    addConstraint(leq(plus(o6_3, 111), 239));
    addConstraint(leq(0, o7));
    addConstraint(leq(plus(o7, 224), 1203));
    addConstraint(leq(0, o7_2));
    addConstraint(leq(plus(o7_2, 224), 235));
    addConstraint(leq(0, o7_3));
    addConstraint(leq(plus(o7_3, 111), 239));
    addConstraint(leq(0, o8));
    addConstraint(leq(plus(o8, 224), 1203));
    addConstraint(leq(0, o8_2));
    addConstraint(leq(plus(o8_2, 224), 235));
    addConstraint(leq(0, o8_3));
    addConstraint(leq(plus(o8_3, 222), 239));
    addConstraint(leq(0, o9));
    addConstraint(leq(plus(o9, 155), 1203));
    addConstraint(leq(0, o9_2));
    addConstraint(leq(plus(o9_2, 224), 235));
    addConstraint(leq(0, o9_3));
    addConstraint(leq(plus(o9_3, 222), 239));
    addConstraint(leq(0, o10));
    addConstraint(leq(plus(o10, 112), 1203));
    addConstraint(leq(0, o10_2));
    addConstraint(leq(plus(o10_2, 224), 235));
    addConstraint(leq(0, o10_3));
    addConstraint(leq(plus(o10_3, 148), 239));
    Vector<GeostObject> geost_obj = new Vector<GeostObject>();
    Vector<ShiftedBox> geost_sb = new Vector<ShiftedBox>();
    IntegerVariable start_8 = makeIntVar("start_8", 0, 0);
    IntegerVariable duration_8 = makeIntVar("duration_8", 1, 1);
    IntegerVariable end_8 = makeIntVar("end_8", 1, 1);
    IntegerVariable sid_8 = makeIntVar("sid_8", 7, 7);
    geost_obj.add(new GeostObject(3, 8, sid_8, new IntegerVariable[] {o2, o2_2, o2_3}, start_8, duration_8, end_8));
    IntegerVariable start_12 = makeIntVar("start_12", 0, 0);
    IntegerVariable duration_12 = makeIntVar("duration_12", 1, 1);
    IntegerVariable end_12 = makeIntVar("end_12", 1, 1);
    IntegerVariable sid_12 = makeIntVar("sid_12", 11, 11);
    geost_obj.add(new GeostObject(3, 12, sid_12, new IntegerVariable[] {o3, o3_2, o3_3}, start_12, duration_12, end_12));
    IntegerVariable start_13 = makeIntVar("start_13", 0, 0);
    IntegerVariable duration_13 = makeIntVar("duration_13", 1, 1);
    IntegerVariable end_13 = makeIntVar("end_13", 1, 1);
    IntegerVariable sid_13 = makeIntVar("sid_13", 11, 11);
    geost_obj.add(new GeostObject(3, 13, sid_13, new IntegerVariable[] {o4, o4_2, o4_3}, start_13, duration_13, end_13));
    IntegerVariable start_17 = makeIntVar("start_17", 0, 0);
    IntegerVariable duration_17 = makeIntVar("duration_17", 1, 1);
    IntegerVariable end_17 = makeIntVar("end_17", 1, 1);
    IntegerVariable sid_17 = makeIntVar("sid_17", 16, 16);
    geost_obj.add(new GeostObject(3, 17, sid_17, new IntegerVariable[] {o5, o5_2, o5_3}, start_17, duration_17, end_17));
    IntegerVariable start_18 = makeIntVar("start_18", 0, 0);
    IntegerVariable duration_18 = makeIntVar("duration_18", 1, 1);
    IntegerVariable end_18 = makeIntVar("end_18", 1, 1);
    IntegerVariable sid_18 = makeIntVar("sid_18", 7, 7);
    geost_obj.add(new GeostObject(3, 18, sid_18, new IntegerVariable[] {o6, o6_2, o6_3}, start_18, duration_18, end_18));
    IntegerVariable start_19 = makeIntVar("start_19", 0, 0);
    IntegerVariable duration_19 = makeIntVar("duration_19", 1, 1);
    IntegerVariable end_19 = makeIntVar("end_19", 1, 1);
    IntegerVariable sid_19 = makeIntVar("sid_19", 7, 7);
    geost_obj.add(new GeostObject(3, 19, sid_19, new IntegerVariable[] {o7, o7_2, o7_3}, start_19, duration_19, end_19));
    IntegerVariable start_23 = makeIntVar("start_23", 0, 0);
    IntegerVariable duration_23 = makeIntVar("duration_23", 1, 1);
    IntegerVariable end_23 = makeIntVar("end_23", 1, 1);
    IntegerVariable sid_23 = makeIntVar("sid_23", 22, 22);
    geost_obj.add(new GeostObject(3, 23, sid_23, new IntegerVariable[] {o8, o8_2, o8_3}, start_23, duration_23, end_23));
    IntegerVariable start_27 = makeIntVar("start_27", 0, 0);
    IntegerVariable duration_27 = makeIntVar("duration_27", 1, 1);
    IntegerVariable end_27 = makeIntVar("end_27", 1, 1);
    IntegerVariable sid_27 = makeIntVar("sid_27", 26, 26);
    geost_obj.add(new GeostObject(3, 27, sid_27, new IntegerVariable[] {o9, o9_2, o9_3}, start_27, duration_27, end_27));
    IntegerVariable start_31 = makeIntVar("start_31", 0, 0);
    IntegerVariable duration_31 = makeIntVar("duration_31", 1, 1);
    IntegerVariable end_31 = makeIntVar("end_31", 1, 1);
    IntegerVariable sid_31 = makeIntVar("sid_31", 30, 30);
    geost_obj.add(new GeostObject(3, 31, sid_31, new IntegerVariable[] {o10, o10_2, o10_3}, start_31, duration_31, end_31));
    geost_sb.add(new ShiftedBox(7, new int[] {0, 0, 0}, new int[] {224, 224, 111}));
    geost_sb.add(new ShiftedBox(11, new int[] {0, 0, 0}, new int[] {224, 224, 74}));
    geost_sb.add(new ShiftedBox(16, new int[] {0, 0, 0}, new int[] {224, 224, 148}));
    geost_sb.add(new ShiftedBox(22, new int[] {0, 0, 0}, new int[] {224, 224, 222}));
    geost_sb.add(new ShiftedBox(26, new int[] {0, 0, 0}, new int[] {155, 224, 222}));
    geost_sb.add(new ShiftedBox(30, new int[] {0, 0, 0}, new int[] {112, 224, 148}));
    addConstraint(geost(3, geost_obj, geost_sb, non_overlapping(3, geost_obj)));
    Solver s = new CPSolver();
    s.read(rules2cp.interpreter.java.r2cp.model);
    CPSolver.setVerbosity(CPSolver.SEARCH);
    s.attachGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o4_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o4, o4_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o8_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o8, o8_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o3_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o3, o3_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o9_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o9, o9_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o5_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o5, o5_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o2_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o2, o2_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o10_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o10, o10_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o7_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o7, o7_2}))));
    s.addGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o6_3})), new IncreasingDomain()));
    s.addGoal(new DichotomicBranching(new StaticVarOrder(s.getVar(new IntegerVariable[] {o6, o6_2}))));
    s.generateSearchStrategy();
    s.launch();
    CPSolver.flushLogs();
    System.out.println(s.pretty());
    
  }

}
