#!/bin/sh
/usr/local/bin/gnuplot <<EOF
set terminal postscript eps color "Helvetica" 24
# set terminal png medium
set title "Memory consumption for placing N objects"
set xlabel "N objects"
set ylabel "MB"
set output "memory.eps"
plot "memory2.dat" using 1:(\$2/1000000) with lines title "static",  "memory2.dat" using 1:(\$3/1000000) with lines title "dynamic"
set title "Time consumption for placing N objects"
set xlabel "N objects"
set ylabel "seconds"
set output "time.eps"
plot "memory2.dat" using 1:(\$4/1000) with lines notitle
# f(x) = b*x**2 + c*c + d
# fit f(x) "memory2.dat" using 1:2 via b, c, d
# g(x) = a*x**3 + b*x**2 + c*x + d
# fit g(x) "memory2.dat" using 1:3 via a, b, c, d
# g(x) = b*x**2 + c*x + d
# fit g(x) "memory2.dat" using 1:3 via b, c, d
EOF
