:- use_module(library(clpfd)).
:- use_module('/afs/inria.fr/rocq/home/contraintes/common/src/rules2cp/interpreter/prolog/r2cp.pl').
:- init_interpreter.



rcp_first(_A_) :- 
	rcp_var(from(first,0,1), First),
	rcp_rec([start=First,duration=0], _A_).

rcp_first_search(_A_) :- 
	rcp_var(from(first,0,1), First),
	rcp_rec([start=First,duration=0], _A_).

rcp_a1(_A_) :- 
	rcp_var(from(a1,0,1), A1),
	rcp_rec([start=A1,duration=4], _A_).

rcp_a1_search(_A_) :- 
	rcp_var(from(a1,0,1), A1),
	rcp_rec([start=A1,duration=4], _A_).

rcp_a2(_A_) :- 
	rcp_var(from(a2,0,1), A2),
	rcp_rec([start=A2,duration=2], _A_).

rcp_a2_search(_A_) :- 
	rcp_var(from(a2,0,1), A2),
	rcp_rec([start=A2,duration=2], _A_).

rcp_a3(_A_) :- 
	rcp_var(from(a3,0,1), A3),
	rcp_rec([start=A3,duration=2], _A_).

rcp_a3_search(_A_) :- 
	rcp_var(from(a3,0,1), A3),
	rcp_rec([start=A3,duration=2], _A_).

rcp_a4(_A_) :- 
	rcp_var(from(a4,0,1), A4),
	rcp_rec([start=A4,duration=2], _A_).

rcp_a4_search(_A_) :- 
	rcp_var(from(a4,0,1), A4),
	rcp_rec([start=A4,duration=2], _A_).

rcp_a5(_A_) :- 
	rcp_var(from(a5,0,1), A5),
	rcp_rec([start=A5,duration=2], _A_).

rcp_a5_search(_A_) :- 
	rcp_var(from(a5,0,1), A5),
	rcp_rec([start=A5,duration=2], _A_).

rcp_a6(_A_) :- 
	rcp_var(from(a6,0,1), A6),
	rcp_rec([start=A6,duration=5], _A_).

rcp_a6_search(_A_) :- 
	rcp_var(from(a6,0,1), A6),
	rcp_rec([start=A6,duration=5], _A_).

rcp_p1(_A_) :- 
	rcp_var(from(p1,0,1), P1),
	rcp_rec([start=P1,duration=20], _A_).

rcp_p1_search(_A_) :- 
	rcp_var(from(p1,0,1), P1),
	rcp_rec([start=P1,duration=20], _A_).

rcp_p2(_A_) :- 
	rcp_var(from(p2,0,1), P2),
	rcp_rec([start=P2,duration=13], _A_).

rcp_p2_search(_A_) :- 
	rcp_var(from(p2,0,1), P2),
	rcp_rec([start=P2,duration=13], _A_).

rcp_ue(_A_) :- 
	rcp_var(from(ue,0,1), Ue),
	rcp_rec([start=Ue,duration=10], _A_).

rcp_ue_search(_A_) :- 
	rcp_var(from(ue,0,1), Ue),
	rcp_rec([start=Ue,duration=10], _A_).

rcp_s1(_A_) :- 
	rcp_var(from(s1,0,1), S1),
	rcp_rec([start=S1,duration=8], _A_).

rcp_s1_search(_A_) :- 
	rcp_var(from(s1,0,1), S1),
	rcp_rec([start=S1,duration=8], _A_).

rcp_s2(_A_) :- 
	rcp_var(from(s2,0,1), S2),
	rcp_rec([start=S2,duration=4], _A_).

rcp_s2_search(_A_) :- 
	rcp_var(from(s2,0,1), S2),
	rcp_rec([start=S2,duration=4], _A_).

rcp_s3(_A_) :- 
	rcp_var(from(s3,0,1), S3),
	rcp_rec([start=S3,duration=4], _A_).

rcp_s3_search(_A_) :- 
	rcp_var(from(s3,0,1), S3),
	rcp_rec([start=S3,duration=4], _A_).

rcp_s4(_A_) :- 
	rcp_var(from(s4,0,1), S4),
	rcp_rec([start=S4,duration=4], _A_).

rcp_s4_search(_A_) :- 
	rcp_var(from(s4,0,1), S4),
	rcp_rec([start=S4,duration=4], _A_).

rcp_s5(_A_) :- 
	rcp_var(from(s5,0,1), S5),
	rcp_rec([start=S5,duration=4], _A_).

rcp_s5_search(_A_) :- 
	rcp_var(from(s5,0,1), S5),
	rcp_rec([start=S5,duration=4], _A_).

rcp_s6(_A_) :- 
	rcp_var(from(s6,0,1), S6),
	rcp_rec([start=S6,duration=10], _A_).

rcp_s6_search(_A_) :- 
	rcp_var(from(s6,0,1), S6),
	rcp_rec([start=S6,duration=10], _A_).

rcp_b1(_A_) :- 
	rcp_var(from(b1,0,1), B1),
	rcp_rec([start=B1,duration=1], _A_).

rcp_b1_search(_A_) :- 
	rcp_var(from(b1,0,1), B1),
	rcp_rec([start=B1,duration=1], _A_).

rcp_b2(_A_) :- 
	rcp_var(from(b2,0,1), B2),
	rcp_rec([start=B2,duration=1], _A_).

rcp_b2_search(_A_) :- 
	rcp_var(from(b2,0,1), B2),
	rcp_rec([start=B2,duration=1], _A_).

rcp_b3(_A_) :- 
	rcp_var(from(b3,0,1), B3),
	rcp_rec([start=B3,duration=1], _A_).

rcp_b3_search(_A_) :- 
	rcp_var(from(b3,0,1), B3),
	rcp_rec([start=B3,duration=1], _A_).

rcp_b4(_A_) :- 
	rcp_var(from(b4,0,1), B4),
	rcp_rec([start=B4,duration=1], _A_).

rcp_b4_search(_A_) :- 
	rcp_var(from(b4,0,1), B4),
	rcp_rec([start=B4,duration=1], _A_).

rcp_b5(_A_) :- 
	rcp_var(from(b5,0,1), B5),
	rcp_rec([start=B5,duration=1], _A_).

rcp_b5_search(_A_) :- 
	rcp_var(from(b5,0,1), B5),
	rcp_rec([start=B5,duration=1], _A_).

rcp_b6(_A_) :- 
	rcp_var(from(b6,0,1), B6),
	rcp_rec([start=B6,duration=1], _A_).

rcp_b6_search(_A_) :- 
	rcp_var(from(b6,0,1), B6),
	rcp_rec([start=B6,duration=1], _A_).

rcp_ab1(_A_) :- 
	rcp_var(from(ab1,0,1), Ab1),
	rcp_rec([start=Ab1,duration=1], _A_).

rcp_ab1_search(_A_) :- 
	rcp_var(from(ab1,0,1), Ab1),
	rcp_rec([start=Ab1,duration=1], _A_).

rcp_ab2(_A_) :- 
	rcp_var(from(ab2,0,1), Ab2),
	rcp_rec([start=Ab2,duration=1], _A_).

rcp_ab2_search(_A_) :- 
	rcp_var(from(ab2,0,1), Ab2),
	rcp_rec([start=Ab2,duration=1], _A_).

rcp_ab3(_A_) :- 
	rcp_var(from(ab3,0,1), Ab3),
	rcp_rec([start=Ab3,duration=1], _A_).

rcp_ab3_search(_A_) :- 
	rcp_var(from(ab3,0,1), Ab3),
	rcp_rec([start=Ab3,duration=1], _A_).

rcp_ab4(_A_) :- 
	rcp_var(from(ab4,0,1), Ab4),
	rcp_rec([start=Ab4,duration=1], _A_).

rcp_ab4_search(_A_) :- 
	rcp_var(from(ab4,0,1), Ab4),
	rcp_rec([start=Ab4,duration=1], _A_).

rcp_ab5(_A_) :- 
	rcp_var(from(ab5,0,1), Ab5),
	rcp_rec([start=Ab5,duration=1], _A_).

rcp_ab5_search(_A_) :- 
	rcp_var(from(ab5,0,1), Ab5),
	rcp_rec([start=Ab5,duration=1], _A_).

rcp_ab6(_A_) :- 
	rcp_var(from(ab6,0,1), Ab6),
	rcp_rec([start=Ab6,duration=1], _A_).

rcp_ab6_search(_A_) :- 
	rcp_var(from(ab6,0,1), Ab6),
	rcp_rec([start=Ab6,duration=1], _A_).

rcp_m1(_A_) :- 
	rcp_var(from(m1,0,1), M1),
	rcp_rec([start=M1,duration=16], _A_).

rcp_m1_search(_A_) :- 
	rcp_var(from(m1,0,1), M1),
	rcp_rec([start=M1,duration=16], _A_).

rcp_m2(_A_) :- 
	rcp_var(from(m2,0,1), M2),
	rcp_rec([start=M2,duration=8], _A_).

rcp_m2_search(_A_) :- 
	rcp_var(from(m2,0,1), M2),
	rcp_rec([start=M2,duration=8], _A_).

rcp_m3(_A_) :- 
	rcp_var(from(m3,0,1), M3),
	rcp_rec([start=M3,duration=8], _A_).

rcp_m3_search(_A_) :- 
	rcp_var(from(m3,0,1), M3),
	rcp_rec([start=M3,duration=8], _A_).

rcp_m4(_A_) :- 
	rcp_var(from(m4,0,1), M4),
	rcp_rec([start=M4,duration=8], _A_).

rcp_m4_search(_A_) :- 
	rcp_var(from(m4,0,1), M4),
	rcp_rec([start=M4,duration=8], _A_).

rcp_m5(_A_) :- 
	rcp_var(from(m5,0,1), M5),
	rcp_rec([start=M5,duration=8], _A_).

rcp_m5_search(_A_) :- 
	rcp_var(from(m5,0,1), M5),
	rcp_rec([start=M5,duration=8], _A_).

rcp_m6(_A_) :- 
	rcp_var(from(m6,0,1), M6),
	rcp_rec([start=M6,duration=20], _A_).

rcp_m6_search(_A_) :- 
	rcp_var(from(m6,0,1), M6),
	rcp_rec([start=M6,duration=20], _A_).

rcp_l1(_A_) :- 
	rcp_var(from(l1,0,1), L1),
	rcp_rec([start=L1,duration=2], _A_).

rcp_l1_search(_A_) :- 
	rcp_var(from(l1,0,1), L1),
	rcp_rec([start=L1,duration=2], _A_).

rcp_t1(_A_) :- 
	rcp_var(from(t1,0,1), T1),
	rcp_rec([start=T1,duration=12], _A_).

rcp_t1_search(_A_) :- 
	rcp_var(from(t1,0,1), T1),
	rcp_rec([start=T1,duration=12], _A_).

rcp_t2(_A_) :- 
	rcp_var(from(t2,0,1), T2),
	rcp_rec([start=T2,duration=12], _A_).

rcp_t2_search(_A_) :- 
	rcp_var(from(t2,0,1), T2),
	rcp_rec([start=T2,duration=12], _A_).

rcp_t3(_A_) :- 
	rcp_var(from(t3,0,1), T3),
	rcp_rec([start=T3,duration=12], _A_).

rcp_t3_search(_A_) :- 
	rcp_var(from(t3,0,1), T3),
	rcp_rec([start=T3,duration=12], _A_).

rcp_t4(_A_) :- 
	rcp_var(from(t4,0,1), T4),
	rcp_rec([start=T4,duration=12], _A_).

rcp_t4_search(_A_) :- 
	rcp_var(from(t4,0,1), T4),
	rcp_rec([start=T4,duration=12], _A_).

rcp_t5(_A_) :- 
	rcp_var(from(t5,0,1), T5),
	rcp_rec([start=T5,duration=12], _A_).

rcp_t5_search(_A_) :- 
	rcp_var(from(t5,0,1), T5),
	rcp_rec([start=T5,duration=12], _A_).

rcp_ua(_A_) :- 
	rcp_var(from(ua,0,1), Ua),
	rcp_rec([start=Ua,duration=10], _A_).

rcp_ua_search(_A_) :- 
	rcp_var(from(ua,0,1), Ua),
	rcp_rec([start=Ua,duration=10], _A_).

rcp_v1(_A_) :- 
	rcp_var(from(v1,0,1), V1),
	rcp_rec([start=V1,duration=15], _A_).

rcp_v1_search(_A_) :- 
	rcp_var(from(v1,0,1), V1),
	rcp_rec([start=V1,duration=15], _A_).

rcp_v2(_A_) :- 
	rcp_var(from(v2,0,1), V2),
	rcp_rec([start=V2,duration=10], _A_).

rcp_v2_search(_A_) :- 
	rcp_var(from(v2,0,1), V2),
	rcp_rec([start=V2,duration=10], _A_).

rcp_k1(_A_) :- 
	rcp_var(from(k1,0,1), K1),
	rcp_rec([start=K1,duration=0], _A_).

rcp_k1_search(_A_) :- 
	rcp_var(from(k1,0,1), K1),
	rcp_rec([start=K1,duration=0], _A_).

rcp_k2(_A_) :- 
	rcp_var(from(k2,0,1), K2),
	rcp_rec([start=K2,duration=0], _A_).

rcp_k2_search(_A_) :- 
	rcp_var(from(k2,0,1), K2),
	rcp_rec([start=K2,duration=0], _A_).

rcp_last(_A_) :- 
	rcp_var(from(last,0,1), Last),
	rcp_rec([start=Last,duration=0], _A_).

rcp_last_search(_A_) :- 
	rcp_var(from(last,0,1), Last),
	rcp_rec([start=Last,duration=0], _A_).

rcp_cost(_B_) :- 
	rcp_last(_A_),
	rcp_att(start, _A_, _B_).

rcp_cost_search(_B_) :- 
	rcp_last_search(_A_),
	rcp_att(start, _A_, _B_).

rcp_maxDuration_foldr_1([], _, []) :- 
	!.
rcp_maxDuration_foldr_1([T_107|Tail], [], [_A_|_B_]) :- 
	rcp_att(duration, T_107, _A_),
	rcp_maxDuration_foldr_1(Tail, [], _B_).

rcp_maxDuration_foldr_1_search([], _, []) :- 
	!.
rcp_maxDuration_foldr_1_search([T_107|Tail], [], [_C_|_D_]) :- 
	rcp_att(duration, T_107, _C_),
	rcp_maxDuration_foldr_1_search(Tail, [], _D_).

rcp_maxDuration(_C_) :- 
	rcp_tasks(_A_),
	rcp_maxDuration_foldr_1(_A_, [], _B_),
	rcp_sum(_B_, _C_).

rcp_maxDuration_search(_C_) :- 
	rcp_tasks_search(_A_),
	rcp_maxDuration_foldr_1_search(_A_, [], _B_),
	rcp_sum_search(_B_, _C_).

rcp_tasks(_V1_) :- 
	rcp_first(_A_),
	rcp_a1(_B_),
	rcp_a2(_C_),
	rcp_a3(_D_),
	rcp_a4(_E_),
	rcp_a5(_F_),
	rcp_a6(_G_),
	rcp_p1(_H_),
	rcp_p2(_I_),
	rcp_ue(_J_),
	rcp_s1(_K_),
	rcp_s2(_L_),
	rcp_s3(_M_),
	rcp_s4(_N_),
	rcp_s5(_O_),
	rcp_s6(_P_),
	rcp_b1(_Q_),
	rcp_b2(_R_),
	rcp_b3(_S_),
	rcp_b4(_T_),
	rcp_b5(_U_),
	rcp_b6(_V_),
	rcp_ab1(_W_),
	rcp_ab2(_X_),
	rcp_ab3(_Y_),
	rcp_ab4(_Z_),
	rcp_ab5(_B1_),
	rcp_ab6(_C1_),
	rcp_m1(_D1_),
	rcp_m2(_E1_),
	rcp_m3(_F1_),
	rcp_m4(_G1_),
	rcp_m5(_H1_),
	rcp_m6(_I1_),
	rcp_l1(_J1_),
	rcp_t1(_K1_),
	rcp_t2(_L1_),
	rcp_t3(_M1_),
	rcp_t4(_N1_),
	rcp_t5(_O1_),
	rcp_ua(_P1_),
	rcp_v1(_Q1_),
	rcp_v2(_R1_),
	rcp_k1(_S1_),
	rcp_k2(_T1_),
	rcp_last(_U1_),
	_V1_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_,_H_,_I_,_J_,_K_,_L_,_M_,_N_,_O_,_P_,_Q_,_R_,_S_,_T_,_U_,_V_,_W_,_X_,_Y_,_Z_,_B1_,_C1_,_D1_,_E1_,_F1_,_G1_,_H1_,_I1_,_J1_,_K1_,_L1_,_M1_,_N1_,_O1_,_P1_,_Q1_,_R1_,_S1_,_T1_,_U1_].

rcp_tasks_search(_V1_) :- 
	rcp_first_search(_A_),
	rcp_a1_search(_B_),
	rcp_a2_search(_C_),
	rcp_a3_search(_D_),
	rcp_a4_search(_E_),
	rcp_a5_search(_F_),
	rcp_a6_search(_G_),
	rcp_p1_search(_H_),
	rcp_p2_search(_I_),
	rcp_ue_search(_J_),
	rcp_s1_search(_K_),
	rcp_s2_search(_L_),
	rcp_s3_search(_M_),
	rcp_s4_search(_N_),
	rcp_s5_search(_O_),
	rcp_s6_search(_P_),
	rcp_b1_search(_Q_),
	rcp_b2_search(_R_),
	rcp_b3_search(_S_),
	rcp_b4_search(_T_),
	rcp_b5_search(_U_),
	rcp_b6_search(_V_),
	rcp_ab1_search(_W_),
	rcp_ab2_search(_X_),
	rcp_ab3_search(_Y_),
	rcp_ab4_search(_Z_),
	rcp_ab5_search(_B1_),
	rcp_ab6_search(_C1_),
	rcp_m1_search(_D1_),
	rcp_m2_search(_E1_),
	rcp_m3_search(_F1_),
	rcp_m4_search(_G1_),
	rcp_m5_search(_H1_),
	rcp_m6_search(_I1_),
	rcp_l1_search(_J1_),
	rcp_t1_search(_K1_),
	rcp_t2_search(_L1_),
	rcp_t3_search(_M1_),
	rcp_t4_search(_N1_),
	rcp_t5_search(_O1_),
	rcp_ua_search(_P1_),
	rcp_v1_search(_Q1_),
	rcp_v2_search(_R1_),
	rcp_k1_search(_S1_),
	rcp_k2_search(_T1_),
	rcp_last_search(_U1_),
	_V1_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_,_H_,_I_,_J_,_K_,_L_,_M_,_N_,_O_,_P_,_Q_,_R_,_S_,_T_,_U_,_V_,_W_,_X_,_Y_,_Z_,_B1_,_C1_,_D1_,_E1_,_F1_,_G1_,_H1_,_I1_,_J1_,_K1_,_L1_,_M1_,_N1_,_O1_,_P1_,_Q1_,_R1_,_S1_,_T1_,_U1_].

rcp_precedences_list(_D5_) :- 
	rcp_first(_A_),
	rcp_a1(_B_),
	rcp_first(_C_),
	rcp_a2(_D_),
	rcp_first(_E_),
	rcp_a3(_F_),
	rcp_first(_G_),
	rcp_a4(_H_),
	rcp_first(_I_),
	rcp_a5(_J_),
	rcp_first(_K_),
	rcp_a6(_L_),
	rcp_first(_M_),
	rcp_ue(_N_),
	rcp_a1(_O_),
	rcp_s1(_P_),
	rcp_a2(_Q_),
	rcp_s2(_R_),
	rcp_a5(_S_),
	rcp_s5(_T_),
	rcp_a6(_U_),
	rcp_s6(_V_),
	rcp_a3(_W_),
	rcp_p1(_X_),
	rcp_a4(_Y_),
	rcp_p2(_Z_),
	rcp_p1(_B1_),
	rcp_s3(_C1_),
	rcp_p2(_D1_),
	rcp_s4(_E1_),
	rcp_p1(_F1_),
	rcp_k1(_G1_),
	rcp_p2(_H1_),
	rcp_k1(_I1_),
	rcp_s1(_J1_),
	rcp_b1(_K1_),
	rcp_s2(_L1_),
	rcp_b2(_M1_),
	rcp_s3(_N1_),
	rcp_b3(_O1_),
	rcp_s4(_P1_),
	rcp_b4(_Q1_),
	rcp_s5(_R1_),
	rcp_b5(_S1_),
	rcp_s6(_T1_),
	rcp_b6(_U1_),
	rcp_b1(_V1_),
	rcp_ab1(_W1_),
	rcp_b2(_X1_),
	rcp_ab2(_Y1_),
	rcp_b3(_Z1_),
	rcp_ab3(_A2_),
	rcp_b4(_B2_),
	rcp_ab4(_C2_),
	rcp_b5(_D2_),
	rcp_ab5(_E2_),
	rcp_b6(_F2_),
	rcp_ab6(_G2_),
	rcp_ab1(_H2_),
	rcp_m1(_I2_),
	rcp_ab2(_J2_),
	rcp_m2(_K2_),
	rcp_ab3(_L2_),
	rcp_m3(_M2_),
	rcp_ab4(_N2_),
	rcp_m4(_O2_),
	rcp_ab5(_P2_),
	rcp_m5(_Q2_),
	rcp_ab6(_R2_),
	rcp_m6(_S2_),
	rcp_m1(_T2_),
	rcp_t1(_U2_),
	rcp_m2(_V2_),
	rcp_t1(_W2_),
	rcp_m2(_X2_),
	rcp_t2(_Y2_),
	rcp_m3(_Z2_),
	rcp_t2(_A3_),
	rcp_m3(_B3_),
	rcp_t3(_C3_),
	rcp_m4(_D3_),
	rcp_t3(_E3_),
	rcp_m4(_F3_),
	rcp_t4(_G3_),
	rcp_m5(_H3_),
	rcp_t4(_I3_),
	rcp_m5(_J3_),
	rcp_t5(_K3_),
	rcp_m6(_L3_),
	rcp_t5(_M3_),
	rcp_m1(_N3_),
	rcp_k2(_O3_),
	rcp_m2(_P3_),
	rcp_k2(_Q3_),
	rcp_m3(_R3_),
	rcp_k2(_S3_),
	rcp_m4(_T3_),
	rcp_k2(_U3_),
	rcp_m5(_V3_),
	rcp_k2(_W3_),
	rcp_m6(_X3_),
	rcp_k2(_Y3_),
	rcp_l1(_Z3_),
	rcp_t1(_A4_),
	rcp_l1(_B4_),
	rcp_t2(_C4_),
	rcp_l1(_D4_),
	rcp_t3(_E4_),
	rcp_l1(_F4_),
	rcp_t4(_G4_),
	rcp_l1(_H4_),
	rcp_t5(_I4_),
	rcp_t1(_J4_),
	rcp_v1(_K4_),
	rcp_t5(_L4_),
	rcp_v2(_M4_),
	rcp_t2(_N4_),
	rcp_last(_O4_),
	rcp_t3(_P4_),
	rcp_last(_Q4_),
	rcp_t4(_R4_),
	rcp_last(_S4_),
	rcp_v1(_T4_),
	rcp_last(_U4_),
	rcp_v2(_V4_),
	rcp_last(_W4_),
	rcp_ua(_X4_),
	rcp_last(_Y4_),
	rcp_k1(_Z4_),
	rcp_last(_A5_),
	rcp_k2(_B5_),
	rcp_last(_C5_),
	_D5_=[[_A_,_B_],[_C_,_D_],[_E_,_F_],[_G_,_H_],[_I_,_J_],[_K_,_L_],[_M_,_N_],[_O_,_P_],[_Q_,_R_],[_S_,_T_],[_U_,_V_],[_W_,_X_],[_Y_,_Z_],[_B1_,_C1_],[_D1_,_E1_],[_F1_,_G1_],[_H1_,_I1_],[_J1_,_K1_],[_L1_,_M1_],[_N1_,_O1_],[_P1_,_Q1_],[_R1_,_S1_],[_T1_,_U1_],[_V1_,_W1_],[_X1_,_Y1_],[_Z1_,_A2_],[_B2_,_C2_],[_D2_,_E2_],[_F2_,_G2_],[_H2_,_I2_],[_J2_,_K2_],[_L2_,_M2_],[_N2_,_O2_],[_P2_,_Q2_],[_R2_,_S2_],[_T2_,_U2_],[_V2_,_W2_],[_X2_,_Y2_],[_Z2_,_A3_],[_B3_,_C3_],[_D3_,_E3_],[_F3_,_G3_],[_H3_,_I3_],[_J3_,_K3_],[_L3_,_M3_],[_N3_,_O3_],[_P3_,_Q3_],[_R3_,_S3_],[_T3_,_U3_],[_V3_,_W3_],[_X3_,_Y3_],[_Z3_,_A4_],[_B4_,_C4_],[_D4_,_E4_],[_F4_,_G4_],[_H4_,_I4_],[_J4_,_K4_],[_L4_,_M4_],[_N4_,_O4_],[_P4_,_Q4_],[_R4_,_S4_],[_T4_,_U4_],[_V4_,_W4_],[_X4_,_Y4_],[_Z4_,_A5_],[_B5_,_C5_]].

rcp_precedences_list_search(_D5_) :- 
	rcp_first_search(_A_),
	rcp_a1_search(_B_),
	rcp_first_search(_C_),
	rcp_a2_search(_D_),
	rcp_first_search(_E_),
	rcp_a3_search(_F_),
	rcp_first_search(_G_),
	rcp_a4_search(_H_),
	rcp_first_search(_I_),
	rcp_a5_search(_J_),
	rcp_first_search(_K_),
	rcp_a6_search(_L_),
	rcp_first_search(_M_),
	rcp_ue_search(_N_),
	rcp_a1_search(_O_),
	rcp_s1_search(_P_),
	rcp_a2_search(_Q_),
	rcp_s2_search(_R_),
	rcp_a5_search(_S_),
	rcp_s5_search(_T_),
	rcp_a6_search(_U_),
	rcp_s6_search(_V_),
	rcp_a3_search(_W_),
	rcp_p1_search(_X_),
	rcp_a4_search(_Y_),
	rcp_p2_search(_Z_),
	rcp_p1_search(_B1_),
	rcp_s3_search(_C1_),
	rcp_p2_search(_D1_),
	rcp_s4_search(_E1_),
	rcp_p1_search(_F1_),
	rcp_k1_search(_G1_),
	rcp_p2_search(_H1_),
	rcp_k1_search(_I1_),
	rcp_s1_search(_J1_),
	rcp_b1_search(_K1_),
	rcp_s2_search(_L1_),
	rcp_b2_search(_M1_),
	rcp_s3_search(_N1_),
	rcp_b3_search(_O1_),
	rcp_s4_search(_P1_),
	rcp_b4_search(_Q1_),
	rcp_s5_search(_R1_),
	rcp_b5_search(_S1_),
	rcp_s6_search(_T1_),
	rcp_b6_search(_U1_),
	rcp_b1_search(_V1_),
	rcp_ab1_search(_W1_),
	rcp_b2_search(_X1_),
	rcp_ab2_search(_Y1_),
	rcp_b3_search(_Z1_),
	rcp_ab3_search(_A2_),
	rcp_b4_search(_B2_),
	rcp_ab4_search(_C2_),
	rcp_b5_search(_D2_),
	rcp_ab5_search(_E2_),
	rcp_b6_search(_F2_),
	rcp_ab6_search(_G2_),
	rcp_ab1_search(_H2_),
	rcp_m1_search(_I2_),
	rcp_ab2_search(_J2_),
	rcp_m2_search(_K2_),
	rcp_ab3_search(_L2_),
	rcp_m3_search(_M2_),
	rcp_ab4_search(_N2_),
	rcp_m4_search(_O2_),
	rcp_ab5_search(_P2_),
	rcp_m5_search(_Q2_),
	rcp_ab6_search(_R2_),
	rcp_m6_search(_S2_),
	rcp_m1_search(_T2_),
	rcp_t1_search(_U2_),
	rcp_m2_search(_V2_),
	rcp_t1_search(_W2_),
	rcp_m2_search(_X2_),
	rcp_t2_search(_Y2_),
	rcp_m3_search(_Z2_),
	rcp_t2_search(_A3_),
	rcp_m3_search(_B3_),
	rcp_t3_search(_C3_),
	rcp_m4_search(_D3_),
	rcp_t3_search(_E3_),
	rcp_m4_search(_F3_),
	rcp_t4_search(_G3_),
	rcp_m5_search(_H3_),
	rcp_t4_search(_I3_),
	rcp_m5_search(_J3_),
	rcp_t5_search(_K3_),
	rcp_m6_search(_L3_),
	rcp_t5_search(_M3_),
	rcp_m1_search(_N3_),
	rcp_k2_search(_O3_),
	rcp_m2_search(_P3_),
	rcp_k2_search(_Q3_),
	rcp_m3_search(_R3_),
	rcp_k2_search(_S3_),
	rcp_m4_search(_T3_),
	rcp_k2_search(_U3_),
	rcp_m5_search(_V3_),
	rcp_k2_search(_W3_),
	rcp_m6_search(_X3_),
	rcp_k2_search(_Y3_),
	rcp_l1_search(_Z3_),
	rcp_t1_search(_A4_),
	rcp_l1_search(_B4_),
	rcp_t2_search(_C4_),
	rcp_l1_search(_D4_),
	rcp_t3_search(_E4_),
	rcp_l1_search(_F4_),
	rcp_t4_search(_G4_),
	rcp_l1_search(_H4_),
	rcp_t5_search(_I4_),
	rcp_t1_search(_J4_),
	rcp_v1_search(_K4_),
	rcp_t5_search(_L4_),
	rcp_v2_search(_M4_),
	rcp_t2_search(_N4_),
	rcp_last_search(_O4_),
	rcp_t3_search(_P4_),
	rcp_last_search(_Q4_),
	rcp_t4_search(_R4_),
	rcp_last_search(_S4_),
	rcp_v1_search(_T4_),
	rcp_last_search(_U4_),
	rcp_v2_search(_V4_),
	rcp_last_search(_W4_),
	rcp_ua_search(_X4_),
	rcp_last_search(_Y4_),
	rcp_k1_search(_Z4_),
	rcp_last_search(_A5_),
	rcp_k2_search(_B5_),
	rcp_last_search(_C5_),
	_D5_=[[_A_,_B_],[_C_,_D_],[_E_,_F_],[_G_,_H_],[_I_,_J_],[_K_,_L_],[_M_,_N_],[_O_,_P_],[_Q_,_R_],[_S_,_T_],[_U_,_V_],[_W_,_X_],[_Y_,_Z_],[_B1_,_C1_],[_D1_,_E1_],[_F1_,_G1_],[_H1_,_I1_],[_J1_,_K1_],[_L1_,_M1_],[_N1_,_O1_],[_P1_,_Q1_],[_R1_,_S1_],[_T1_,_U1_],[_V1_,_W1_],[_X1_,_Y1_],[_Z1_,_A2_],[_B2_,_C2_],[_D2_,_E2_],[_F2_,_G2_],[_H2_,_I2_],[_J2_,_K2_],[_L2_,_M2_],[_N2_,_O2_],[_P2_,_Q2_],[_R2_,_S2_],[_T2_,_U2_],[_V2_,_W2_],[_X2_,_Y2_],[_Z2_,_A3_],[_B3_,_C3_],[_D3_,_E3_],[_F3_,_G3_],[_H3_,_I3_],[_J3_,_K3_],[_L3_,_M3_],[_N3_,_O3_],[_P3_,_Q3_],[_R3_,_S3_],[_T3_,_U3_],[_V3_,_W3_],[_X3_,_Y3_],[_Z3_,_A4_],[_B4_,_C4_],[_D4_,_E4_],[_F4_,_G4_],[_H4_,_I4_],[_J4_,_K4_],[_L4_,_M4_],[_N4_,_O4_],[_P4_,_Q4_],[_R4_,_S4_],[_T4_,_U4_],[_V4_,_W4_],[_X4_,_Y4_],[_Z4_,_A5_],[_B5_,_C5_]].

rcp_resource_crane(_G_) :- 
	rcp_l1(_A_),
	rcp_t1(_B_),
	rcp_t2(_C_),
	rcp_t3(_D_),
	rcp_t4(_E_),
	rcp_t5(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_crane_search(_G_) :- 
	rcp_l1_search(_A_),
	rcp_t1_search(_B_),
	rcp_t2_search(_C_),
	rcp_t3_search(_D_),
	rcp_t4_search(_E_),
	rcp_t5_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_bricklaying(_G_) :- 
	rcp_m1(_A_),
	rcp_m2(_B_),
	rcp_m3(_C_),
	rcp_m4(_D_),
	rcp_m5(_E_),
	rcp_m6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_bricklaying_search(_G_) :- 
	rcp_m1_search(_A_),
	rcp_m2_search(_B_),
	rcp_m3_search(_C_),
	rcp_m4_search(_D_),
	rcp_m5_search(_E_),
	rcp_m6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_schal(_G_) :- 
	rcp_s1(_A_),
	rcp_s2(_B_),
	rcp_s3(_C_),
	rcp_s4(_D_),
	rcp_s5(_E_),
	rcp_s6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_schal_search(_G_) :- 
	rcp_s1_search(_A_),
	rcp_s2_search(_B_),
	rcp_s3_search(_C_),
	rcp_s4_search(_D_),
	rcp_s5_search(_E_),
	rcp_s6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_excavator(_G_) :- 
	rcp_a1(_A_),
	rcp_a2(_B_),
	rcp_a3(_C_),
	rcp_a4(_D_),
	rcp_a5(_E_),
	rcp_a6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_excavator_search(_G_) :- 
	rcp_a1_search(_A_),
	rcp_a2_search(_B_),
	rcp_a3_search(_C_),
	rcp_a4_search(_D_),
	rcp_a5_search(_E_),
	rcp_a6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_ram(_C_) :- 
	rcp_p1(_A_),
	rcp_p2(_B_),
	_C_=[_A_,_B_].

rcp_resource_ram_search(_C_) :- 
	rcp_p1_search(_A_),
	rcp_p2_search(_B_),
	_C_=[_A_,_B_].

rcp_resource_pump(_G_) :- 
	rcp_b1(_A_),
	rcp_b2(_B_),
	rcp_b3(_C_),
	rcp_b4(_D_),
	rcp_b5(_E_),
	rcp_b6(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_pump_search(_G_) :- 
	rcp_b1_search(_A_),
	rcp_b2_search(_B_),
	rcp_b3_search(_C_),
	rcp_b4_search(_D_),
	rcp_b5_search(_E_),
	rcp_b6_search(_F_),
	_G_=[_A_,_B_,_C_,_D_,_E_,_F_].

rcp_resource_caterpillar(_C_) :- 
	rcp_v1(_A_),
	rcp_v2(_B_),
	_C_=[_A_,_B_].

rcp_resource_caterpillar_search(_C_) :- 
	rcp_v1_search(_A_),
	rcp_v2_search(_B_),
	_C_=[_A_,_B_].

rcp_resources(_H_) :- 
	rcp_resource_crane(_A_),
	rcp_resource_bricklaying(_B_),
	rcp_resource_schal(_C_),
	rcp_resource_excavator(_D_),
	rcp_resource_ram(_E_),
	rcp_resource_pump(_F_),
	rcp_resource_caterpillar(_G_),
	_H_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_].

rcp_resources_search(_H_) :- 
	rcp_resource_crane_search(_A_),
	rcp_resource_bricklaying_search(_B_),
	rcp_resource_schal_search(_C_),
	rcp_resource_excavator_search(_D_),
	rcp_resource_ram_search(_E_),
	rcp_resource_pump_search(_F_),
	rcp_resource_caterpillar_search(_G_),
	_H_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_].

rcp_max_nf_list(_O_) :- 
	rcp_first(_A_),
	rcp_l1(_B_),
	rcp_a1(_C_),
	rcp_s1(_D_),
	rcp_a2(_E_),
	rcp_s2(_F_),
	rcp_a5(_G_),
	rcp_s5(_H_),
	rcp_a6(_I_),
	rcp_s6(_J_),
	rcp_p1(_K_),
	rcp_s3(_L_),
	rcp_p2(_M_),
	rcp_s4(_N_),
	_O_=[[_A_,_B_,30],[_C_,_D_,3],[_E_,_F_,3],[_G_,_H_,3],[_I_,_J_,3],[_K_,_L_,3],[_M_,_N_,3]].

rcp_max_nf_list_search(_O_) :- 
	rcp_first_search(_A_),
	rcp_l1_search(_B_),
	rcp_a1_search(_C_),
	rcp_s1_search(_D_),
	rcp_a2_search(_E_),
	rcp_s2_search(_F_),
	rcp_a5_search(_G_),
	rcp_s5_search(_H_),
	rcp_a6_search(_I_),
	rcp_s6_search(_J_),
	rcp_p1_search(_K_),
	rcp_s3_search(_L_),
	rcp_p2_search(_M_),
	rcp_s4_search(_N_),
	_O_=[[_A_,_B_,30],[_C_,_D_,3],[_E_,_F_,3],[_G_,_H_,3],[_I_,_J_,3],[_K_,_L_,3],[_M_,_N_,3]].

rcp_min_sf_list(_M_) :- 
	rcp_ua(_A_),
	rcp_m1(_B_),
	rcp_ua(_C_),
	rcp_m2(_D_),
	rcp_ua(_E_),
	rcp_m3(_F_),
	rcp_ua(_G_),
	rcp_m4(_H_),
	rcp_ua(_I_),
	rcp_m5(_J_),
	rcp_ua(_K_),
	rcp_m6(_L_),
	_M_=[[_A_,_B_,2],[_C_,_D_,2],[_E_,_F_,2],[_G_,_H_,2],[_I_,_J_,2],[_K_,_L_,2]].

rcp_min_sf_list_search(_M_) :- 
	rcp_ua_search(_A_),
	rcp_m1_search(_B_),
	rcp_ua_search(_C_),
	rcp_m2_search(_D_),
	rcp_ua_search(_E_),
	rcp_m3_search(_F_),
	rcp_ua_search(_G_),
	rcp_m4_search(_H_),
	rcp_ua_search(_I_),
	rcp_m5_search(_J_),
	rcp_ua_search(_K_),
	rcp_m6_search(_L_),
	_M_=[[_A_,_B_,2],[_C_,_D_,2],[_E_,_F_,2],[_G_,_H_,2],[_I_,_J_,2],[_K_,_L_,2]].

rcp_max_ef_list(_M_) :- 
	rcp_s1(_A_),
	rcp_b1(_B_),
	rcp_s2(_C_),
	rcp_b2(_D_),
	rcp_s3(_E_),
	rcp_b3(_F_),
	rcp_s4(_G_),
	rcp_b4(_H_),
	rcp_s5(_I_),
	rcp_b5(_J_),
	rcp_s6(_K_),
	rcp_b6(_L_),
	_M_=[[_A_,_B_,4],[_C_,_D_,4],[_E_,_F_,4],[_G_,_H_,4],[_I_,_J_,4],[_K_,_L_,4]].

rcp_max_ef_list_search(_M_) :- 
	rcp_s1_search(_A_),
	rcp_b1_search(_B_),
	rcp_s2_search(_C_),
	rcp_b2_search(_D_),
	rcp_s3_search(_E_),
	rcp_b3_search(_F_),
	rcp_s4_search(_G_),
	rcp_b4_search(_H_),
	rcp_s5_search(_I_),
	rcp_b5_search(_J_),
	rcp_s6_search(_K_),
	rcp_b6_search(_L_),
	_M_=[[_A_,_B_,4],[_C_,_D_,4],[_E_,_F_,4],[_G_,_H_,4],[_I_,_J_,4],[_K_,_L_,4]].

rcp_min_nf_list(_C_) :- 
	rcp_first(_A_),
	rcp_l1(_B_),
	_C_=[[_A_,_B_,30]].

rcp_min_nf_list_search(_C_) :- 
	rcp_first_search(_A_),
	rcp_l1_search(_B_),
	_C_=[[_A_,_B_,30]].

rcp_min_af_list(_M_) :- 
	rcp_ue(_A_),
	rcp_s1(_B_),
	rcp_ue(_C_),
	rcp_s2(_D_),
	rcp_ue(_E_),
	rcp_s3(_F_),
	rcp_ue(_G_),
	rcp_s4(_H_),
	rcp_ue(_I_),
	rcp_s5(_J_),
	rcp_ue(_K_),
	rcp_s6(_L_),
	_M_=[[_A_,_B_,6],[_C_,_D_,6],[_E_,_F_,6],[_G_,_H_,6],[_I_,_J_,6],[_K_,_L_,6]].

rcp_min_af_list_search(_M_) :- 
	rcp_ue_search(_A_),
	rcp_s1_search(_B_),
	rcp_ue_search(_C_),
	rcp_s2_search(_D_),
	rcp_ue_search(_E_),
	rcp_s3_search(_F_),
	rcp_ue_search(_G_),
	rcp_s4_search(_H_),
	rcp_ue_search(_I_),
	rcp_s5_search(_J_),
	rcp_ue_search(_K_),
	rcp_s6_search(_L_),
	_M_=[[_A_,_B_,6],[_C_,_D_,6],[_E_,_F_,6],[_G_,_H_,6],[_I_,_J_,6],[_K_,_L_,6]].

rcp_sum_foldr_2([], _, 0) :- 
	!.
rcp_sum_foldr_2([X_108|Tail], [L], _B_) :- 
	rcp_sum_foldr_2(Tail, [L], _A_),
	fd_aeq(X_108+_A_, _B_).

rcp_sum_foldr_2_search([], _, 0) :- 
	!.
rcp_sum_foldr_2_search([X_108|Tail], [L], _D_) :- 
	rcp_sum_foldr_2_search(Tail, [L], _C_),
	fd_aeq(X_108+_C_, _D_).

rcp_sum(L, _A_) :- 
	rcp_sum_foldr_2(L, [L], _A_).

rcp_sum_search(L, _A_) :- 
	rcp_sum_foldr_2_search(L, [L], _A_).

rcp_product_foldr_3([], _, 1) :- 
	!.
rcp_product_foldr_3([X_109|Tail], [L], _B_) :- 
	rcp_product_foldr_3(Tail, [L], _A_),
	fd_aeq(X_109*_A_, _B_).

rcp_product_foldr_3_search([], _, 1) :- 
	!.
rcp_product_foldr_3_search([X_109|Tail], [L], _D_) :- 
	rcp_product_foldr_3_search(Tail, [L], _C_),
	fd_aeq(X_109*_C_, _D_).

rcp_product(L, _A_) :- 
	rcp_product_foldr_3(L, [L], _A_).

rcp_product_search(L, _A_) :- 
	rcp_product_foldr_3_search(L, [L], _A_).

rcp_maximum_foldr_4([], _, -268435456) :- 
	!.
rcp_maximum_foldr_4([X_110|Tail], [L], _B_) :- 
	rcp_maximum_foldr_4(Tail, [L], _A_),
	fd_aeq(max(X_110,_A_), _B_).

rcp_maximum_foldr_4_search([], _, -268435456) :- 
	!.
rcp_maximum_foldr_4_search([X_110|Tail], [L], _D_) :- 
	rcp_maximum_foldr_4_search(Tail, [L], _C_),
	fd_aeq(max(X_110,_C_), _D_).

rcp_maximum(L, _A_) :- 
	rcp_maximum_foldr_4(L, [L], _A_).

rcp_maximum_search(L, _A_) :- 
	rcp_maximum_foldr_4_search(L, [L], _A_).

rcp_minimum_foldr_5([], _, 267999999) :- 
	!.
rcp_minimum_foldr_5([X_111|Tail], [L], _B_) :- 
	rcp_minimum_foldr_5(Tail, [L], _A_),
	fd_aeq(min(X_111,_A_), _B_).

rcp_minimum_foldr_5_search([], _, 267999999) :- 
	!.
rcp_minimum_foldr_5_search([X_111|Tail], [L], _D_) :- 
	rcp_minimum_foldr_5_search(Tail, [L], _C_),
	fd_aeq(min(X_111,_C_), _D_).

rcp_minimum(L, _A_) :- 
	rcp_minimum_foldr_5(L, [L], _A_).

rcp_minimum_search(L, _A_) :- 
	rcp_minimum_foldr_5_search(L, [L], _A_).

rcp_end(Task, _C_) :- 
	rcp_att(start, Task, _A_),
	rcp_att(duration, Task, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_end_search(Task, _C_) :- 
	rcp_att(start, Task, _A_),
	rcp_att(duration, Task, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_geost_constraint_foldr_7([], _, []) :- 
	!.
rcp_geost_constraint_foldr_7([S_114|Tail], [Dims,I_112,Items], [_A_|_B_]) :- 
	rcp_att(uid, S_114, _A_),
	rcp_geost_constraint_foldr_7(Tail, [Dims,I_112,Items], _B_).

rcp_geost_constraint_foldr_7_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_7_search([S_114|Tail], [Dims,I_112,Items], [_C_|_D_]) :- 
	rcp_att(uid, S_114, _C_),
	rcp_geost_constraint_foldr_7_search(Tail, [Dims,I_112,Items], _D_).

rcp_geost_constraint_foldr_6([], _, []) :- 
	!.
rcp_geost_constraint_foldr_6([I_112|Tail], [Dims,Items], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_112, _A_),
	rcp_att(shape_index, I_112, _B_),
	rcp_att(shapes, I_112, _C_),
	rcp_geost_constraint_foldr_7(_C_, [Dims,I_112,Items], _D_),
	rcp_att(origin, I_112, _E_),
	rcp_geost_constraint_foldr_6(Tail, [Dims,Items], _F_).

rcp_geost_constraint_foldr_6_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_6_search([I_112|Tail], [Dims,Items], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_112, _G_),
	rcp_att(shape_index, I_112, _H_),
	rcp_att(shapes, I_112, _I_),
	rcp_geost_constraint_foldr_7_search(_I_, [Dims,I_112,Items], _J_),
	rcp_att(origin, I_112, _K_),
	rcp_geost_constraint_foldr_6_search(Tail, [Dims,Items], _L_).

rcp_geost_constraint_foldr_10([], _, []) :- 
	!.
rcp_geost_constraint_foldr_10([SB_120|Tail], [Dims,I_115,Items,S_118], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_118, _A_),
	rcp_att(offset, SB_120, _B_),
	rcp_att(box, SB_120, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_10(Tail, [Dims,I_115,Items,S_118], _E_).

rcp_geost_constraint_foldr_10_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_10_search([SB_120|Tail], [Dims,I_115,Items,S_118], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_118, _F_),
	rcp_att(offset, SB_120, _G_),
	rcp_att(box, SB_120, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_10_search(Tail, [Dims,I_115,Items,S_118], _J_).

rcp_geost_constraint_foldr_9([], _, []) :- 
	!.
rcp_geost_constraint_foldr_9([S_118|Tail], [Dims,I_115,Items], [_B_|_C_]) :- 
	rcp_att(sboxes, S_118, _A_),
	rcp_geost_constraint_foldr_10(_A_, [Dims,I_115,Items,S_118], _B_),
	rcp_geost_constraint_foldr_9(Tail, [Dims,I_115,Items], _C_).

rcp_geost_constraint_foldr_9_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_9_search([S_118|Tail], [Dims,I_115,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_118, _D_),
	rcp_geost_constraint_foldr_10_search(_D_, [Dims,I_115,Items,S_118], _E_),
	rcp_geost_constraint_foldr_9_search(Tail, [Dims,I_115,Items], _F_).

rcp_geost_constraint_foldr_8([], _, []) :- 
	!.
rcp_geost_constraint_foldr_8([I_115|Tail], [Dims,Items], [_B_|_C_]) :- 
	rcp_att(shapes, I_115, _A_),
	rcp_geost_constraint_foldr_9(_A_, [Dims,I_115,Items], _B_),
	rcp_geost_constraint_foldr_8(Tail, [Dims,Items], _C_).

rcp_geost_constraint_foldr_8_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_8_search([I_115|Tail], [Dims,Items], [_E_|_F_]) :- 
	rcp_att(shapes, I_115, _D_),
	rcp_geost_constraint_foldr_9_search(_D_, [Dims,I_115,Items], _E_),
	rcp_geost_constraint_foldr_8_search(Tail, [Dims,Items], _F_).

rcp_non_overlapping(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_6(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_8(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_non_overlapping_search(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_6_search(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_8_search(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_geost_constraint_foldr_12([], _, []) :- 
	!.
rcp_geost_constraint_foldr_12([S_123|Tail], [Dims,F,I_121,Items,Patterns], [_A_|_B_]) :- 
	rcp_att(uid, S_123, _A_),
	rcp_geost_constraint_foldr_12(Tail, [Dims,F,I_121,Items,Patterns], _B_).

rcp_geost_constraint_foldr_12_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_12_search([S_123|Tail], [Dims,F,I_121,Items,Patterns], [_C_|_D_]) :- 
	rcp_att(uid, S_123, _C_),
	rcp_geost_constraint_foldr_12_search(Tail, [Dims,F,I_121,Items,Patterns], _D_).

rcp_geost_constraint_foldr_11([], _, []) :- 
	!.
rcp_geost_constraint_foldr_11([I_121|Tail], [Dims,F,Items,Patterns], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_121, _A_),
	rcp_att(shape_index, I_121, _B_),
	rcp_att(shapes, I_121, _C_),
	rcp_geost_constraint_foldr_12(_C_, [Dims,F,I_121,Items,Patterns], _D_),
	rcp_att(origin, I_121, _E_),
	rcp_geost_constraint_foldr_11(Tail, [Dims,F,Items,Patterns], _F_).

rcp_geost_constraint_foldr_11_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_11_search([I_121|Tail], [Dims,F,Items,Patterns], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_121, _G_),
	rcp_att(shape_index, I_121, _H_),
	rcp_att(shapes, I_121, _I_),
	rcp_geost_constraint_foldr_12_search(_I_, [Dims,F,I_121,Items,Patterns], _J_),
	rcp_att(origin, I_121, _K_),
	rcp_geost_constraint_foldr_11_search(Tail, [Dims,F,Items,Patterns], _L_).

rcp_geost_constraint_foldr_15([], _, []) :- 
	!.
rcp_geost_constraint_foldr_15([SB_129|Tail], [Dims,F,I_124,Items,Patterns,S_127], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_127, _A_),
	rcp_att(offset, SB_129, _B_),
	rcp_att(box, SB_129, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_15(Tail, [Dims,F,I_124,Items,Patterns,S_127], _E_).

rcp_geost_constraint_foldr_15_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_15_search([SB_129|Tail], [Dims,F,I_124,Items,Patterns,S_127], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_127, _F_),
	rcp_att(offset, SB_129, _G_),
	rcp_att(box, SB_129, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_15_search(Tail, [Dims,F,I_124,Items,Patterns,S_127], _J_).

rcp_geost_constraint_foldr_14([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14([S_127|Tail], [Dims,F,I_124,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(sboxes, S_127, _A_),
	rcp_geost_constraint_foldr_15(_A_, [Dims,F,I_124,Items,Patterns,S_127], _B_),
	rcp_geost_constraint_foldr_14(Tail, [Dims,F,I_124,Items,Patterns], _C_).

rcp_geost_constraint_foldr_14_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14_search([S_127|Tail], [Dims,F,I_124,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(sboxes, S_127, _D_),
	rcp_geost_constraint_foldr_15_search(_D_, [Dims,F,I_124,Items,Patterns,S_127], _E_),
	rcp_geost_constraint_foldr_14_search(Tail, [Dims,F,I_124,Items,Patterns], _F_).

rcp_geost_constraint_foldr_13([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13([I_124|Tail], [Dims,F,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(shapes, I_124, _A_),
	rcp_geost_constraint_foldr_14(_A_, [Dims,F,I_124,Items,Patterns], _B_),
	rcp_geost_constraint_foldr_13(Tail, [Dims,F,Items,Patterns], _C_).

rcp_geost_constraint_foldr_13_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13_search([I_124|Tail], [Dims,F,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(shapes, I_124, _D_),
	rcp_geost_constraint_foldr_14_search(_D_, [Dims,F,I_124,Items,Patterns], _E_),
	rcp_geost_constraint_foldr_13_search(Tail, [Dims,F,Items,Patterns], _F_).

rcp_non_overlapping(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_11(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_13(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_non_overlapping_search(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_11_search(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_13_search(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall_search(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_max_nf(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_end(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_, _D_).

rcp_max_nf_search(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_end_search(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_min_nf(T1, T2, N, _G_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	rcp_att(duration, T1, _C_),
	fd_aeq(2*_C_, _D_),
	fd_aeq(_B_+_D_, _E_),
	fd_aeq(_E_+N, _F_),
	fd_geq(_A_, _F_, _G_).

rcp_min_nf_search(T1, T2, N, _G_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	rcp_att(duration, T1, _C_),
	fd_aeq(2*_C_, _D_),
	fd_aeq(_B_+_D_, _E_),
	fd_aeq(_E_+N, _F_),
	fd_geq(_A_, _F_),
	fd_aeq(_G_, 1).

rcp_max_ef(T1, T2, N, _D_) :- 
	rcp_end(T2, _A_),
	rcp_end(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_, _D_).

rcp_max_ef_search(T1, T2, N, _D_) :- 
	rcp_end_search(T2, _A_),
	rcp_end_search(T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_min_af(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_geq(_A_, _C_, _D_).

rcp_min_af_search(T1, T2, N, _D_) :- 
	rcp_att(start, T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_geq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_min_sf(T1, T2, N, _D_) :- 
	rcp_end(T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_, _D_).

rcp_min_sf_search(T1, T2, N, _D_) :- 
	rcp_end_search(T2, _A_),
	rcp_att(start, T1, _B_),
	fd_aeq(_B_+N, _C_),
	fd_leq(_A_, _C_),
	fd_aeq(_D_, 1).

rcp_distances_foldr_16([], _, 1) :- 
	!.
rcp_distances_foldr_16([T_130|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_130, _A_),
	nth1(2, T_130, _B_),
	nth1(3, T_130, _C_),
	rcp_max_nf(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_16(Tail, [], _E_).

rcp_distances_foldr_16_search([], _, 1) :- 
	!.
rcp_distances_foldr_16_search([T_130|Tail], [], _) :- 
	nth1(1, T_130, _G_),
	nth1(2, T_130, _H_),
	nth1(3, T_130, _I_),
	rcp_max_nf_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_16_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_17([], _, 1) :- 
	!.
rcp_distances_foldr_17([T_131|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_131, _A_),
	nth1(2, T_131, _B_),
	nth1(3, T_131, _C_),
	rcp_min_sf(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_17(Tail, [], _E_).

rcp_distances_foldr_17_search([], _, 1) :- 
	!.
rcp_distances_foldr_17_search([T_131|Tail], [], _) :- 
	nth1(1, T_131, _G_),
	nth1(2, T_131, _H_),
	nth1(3, T_131, _I_),
	rcp_min_sf_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_17_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_18([], _, 1) :- 
	!.
rcp_distances_foldr_18([T_132|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_132, _A_),
	nth1(2, T_132, _B_),
	nth1(3, T_132, _C_),
	rcp_max_ef(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_18(Tail, [], _E_).

rcp_distances_foldr_18_search([], _, 1) :- 
	!.
rcp_distances_foldr_18_search([T_132|Tail], [], _) :- 
	nth1(1, T_132, _G_),
	nth1(2, T_132, _H_),
	nth1(3, T_132, _I_),
	rcp_max_ef_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_18_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_19([], _, 1) :- 
	!.
rcp_distances_foldr_19([T_133|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_133, _A_),
	nth1(2, T_133, _B_),
	nth1(3, T_133, _C_),
	rcp_min_nf(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_19(Tail, [], _E_).

rcp_distances_foldr_19_search([], _, 1) :- 
	!.
rcp_distances_foldr_19_search([T_133|Tail], [], _) :- 
	nth1(1, T_133, _G_),
	nth1(2, T_133, _H_),
	nth1(3, T_133, _I_),
	rcp_min_nf_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_19_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances_foldr_20([], _, 1) :- 
	!.
rcp_distances_foldr_20([T_134|Tail], [], _F_) :- 
	fd_and(_D_, _E_, _F_),
	nth1(1, T_134, _A_),
	nth1(2, T_134, _B_),
	nth1(3, T_134, _C_),
	rcp_min_af(_A_, _B_, _C_, _D_),
	rcp_distances_foldr_20(Tail, [], _E_).

rcp_distances_foldr_20_search([], _, 1) :- 
	!.
rcp_distances_foldr_20_search([T_134|Tail], [], _) :- 
	nth1(1, T_134, _G_),
	nth1(2, T_134, _H_),
	nth1(3, T_134, _I_),
	rcp_min_af_search(_G_, _H_, _I_, _J_),
	rcp_assert(_J_),
	rcp_distances_foldr_20_search(Tail, [], _K_),
	rcp_assert(_K_).

rcp_distances(_N_) :- 
	fd_and(_B_, _M_, _N_),
	rcp_max_nf_list(_A_),
	rcp_distances_foldr_16(_A_, [], _B_),
	fd_and(_D_, _L_, _M_),
	rcp_min_sf_list(_C_),
	rcp_distances_foldr_17(_C_, [], _D_),
	fd_and(_F_, _K_, _L_),
	rcp_max_ef_list(_E_),
	rcp_distances_foldr_18(_E_, [], _F_),
	fd_and(_H_, _J_, _K_),
	rcp_min_nf_list(_G_),
	rcp_distances_foldr_19(_G_, [], _H_),
	rcp_min_af_list(_I_),
	rcp_distances_foldr_20(_I_, [], _J_).

rcp_distances_search(_K_) :- 
	rcp_max_nf_list_search(_A_),
	rcp_distances_foldr_16_search(_A_, [], _B_),
	rcp_assert(_B_),
	rcp_min_sf_list_search(_C_),
	rcp_distances_foldr_17_search(_C_, [], _D_),
	rcp_assert(_D_),
	rcp_max_ef_list_search(_E_),
	rcp_distances_foldr_18_search(_E_, [], _F_),
	rcp_assert(_F_),
	rcp_min_nf_list_search(_G_),
	rcp_distances_foldr_19_search(_G_, [], _H_),
	rcp_assert(_H_),
	rcp_min_af_list_search(_I_),
	rcp_distances_foldr_20_search(_I_, [], _J_),
	rcp_assert(_J_),
	fd_aeq(_K_, 1).

rcp_tasks_domain(_D_) :- 
	rcp_tasks(_A_),
	variables(_A_, _B_),
	rcp_maxDuration(_C_),
	domain(_B_, 0, _C_),
	fd_aeq(_D_, 1).

rcp_tasks_domain_search(_D_) :- 
	rcp_tasks_search(_A_),
	variables(_A_, _B_),
	rcp_maxDuration_search(_C_),
	domain(_B_, 0, _C_),
	fd_aeq(_D_, 1).

rcp_prec(T1, T2, _C_) :- 
	rcp_end(T1, _A_),
	rcp_att(start, T2, _B_),
	fd_leq(_A_, _B_, _C_).

rcp_prec_search(T1, T2, _C_) :- 
	rcp_end_search(T1, _A_),
	rcp_att(start, T2, _B_),
	fd_leq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_precedences_foldr_21([], _, 1) :- 
	!.
rcp_precedences_foldr_21([TaskPair_135|Tail], [], _E_) :- 
	fd_and(_C_, _D_, _E_),
	nth1(1, TaskPair_135, _A_),
	nth1(2, TaskPair_135, _B_),
	rcp_prec(_A_, _B_, _C_),
	rcp_precedences_foldr_21(Tail, [], _D_).

rcp_precedences_foldr_21_search([], _, 1) :- 
	!.
rcp_precedences_foldr_21_search([TaskPair_135|Tail], [], _) :- 
	nth1(1, TaskPair_135, _F_),
	nth1(2, TaskPair_135, _G_),
	rcp_prec_search(_F_, _G_, _H_),
	rcp_assert(_H_),
	rcp_precedences_foldr_21_search(Tail, [], _I_),
	rcp_assert(_I_).

rcp_precedences(_B_) :- 
	rcp_precedences_list(_A_),
	rcp_precedences_foldr_21(_A_, [], _B_).

rcp_precedences_search(_B_) :- 
	rcp_precedences_list_search(_A_),
	rcp_precedences_foldr_21_search(_A_, [], _B_).

rcp_disj(T1, T2, _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_prec(T1, T2, _A_),
	rcp_prec(T2, T1, _B_).

rcp_disj_search(T1, T2, _C_) :- 
	(
	rcp_prec_search(T1, T2, _A_),
	rcp_assert(_A_)
	;
	rcp_prec_search(T2, T1, _B_),
	rcp_assert(_B_)
	),
	fd_aeq(_C_, 1).

rcp_disj_pairs_foldr_23([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_23([T2_138|Tail], [T1_136,Tasks], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_implies(_C_, _D_, _E_),
	rcp_att(uid, T1_136, _A_),
	rcp_att(uid, T2_138, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_disj(T1_136, T2_138, _D_),
	rcp_disj_pairs_foldr_23(Tail, [T1_136,Tasks], _F_).

rcp_disj_pairs_foldr_23_search([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_23_search([T2_138|Tail], [T1_136,Tasks], _) :- 
	rcp_att(uid, T1_136, _H_),
	rcp_att(uid, T2_138, _I_),
	rcp_att(uid, T1_136, _J_),
	rcp_att(uid, T2_138, _K_),
	(
	fd_lt(_H_, _I_),
	rcp_disj_search(T1_136, T2_138, _L_),
	fd_equiv(_L_, _M_, 1)
	;
	fd_geq(_J_, _K_),
	fd_aeq(_M_, 1)
	),
	rcp_assert(_M_),
	rcp_disj_pairs_foldr_23_search(Tail, [T1_136,Tasks], _N_),
	rcp_assert(_N_).

rcp_disj_pairs_foldr_22([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_22([T1_136|Tail], [Tasks], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_disj_pairs_foldr_23(Tasks, [T1_136,Tasks], _A_),
	rcp_disj_pairs_foldr_22(Tail, [Tasks], _B_).

rcp_disj_pairs_foldr_22_search([], _, 1) :- 
	!.
rcp_disj_pairs_foldr_22_search([T1_136|Tail], [Tasks], _) :- 
	rcp_disj_pairs_foldr_23_search(Tasks, [T1_136,Tasks], _D_),
	rcp_assert(_D_),
	rcp_disj_pairs_foldr_22_search(Tail, [Tasks], _E_),
	rcp_assert(_E_).

rcp_disj_pairs(Tasks, _A_) :- 
	rcp_disj_pairs_foldr_22(Tasks, [Tasks], _A_).

rcp_disj_pairs_search(Tasks, _A_) :- 
	rcp_disj_pairs_foldr_22_search(Tasks, [Tasks], _A_).

rcp_disjunctives_foldr_24([], _, 1) :- 
	!.
rcp_disjunctives_foldr_24([Tasks_139|Tail], [], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_disj_pairs(Tasks_139, _A_),
	rcp_disjunctives_foldr_24(Tail, [], _B_).

rcp_disjunctives_foldr_24_search([], _, 1) :- 
	!.
rcp_disjunctives_foldr_24_search([Tasks_139|Tail], [], _) :- 
	rcp_disj_pairs_search(Tasks_139, _D_),
	rcp_assert(_D_),
	rcp_disjunctives_foldr_24_search(Tail, [], _E_),
	rcp_assert(_E_).

rcp_disjunctives(_B_) :- 
	rcp_resources(_A_),
	rcp_disjunctives_foldr_24(_A_, [], _B_).

rcp_disjunctives_search(_B_) :- 
	rcp_resources_search(_A_),
	rcp_disjunctives_foldr_24_search(_A_, [], _B_).

rcp_minimize_completion_time(_E_) :- 
	rcp_cost(_D_),
	minimize((((rcp_tasks_search(_B_),variables(_B_,_C_)),(rcp_disjunctives_search(_A_),rcp_assert(_A_)),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_),
	fd_aeq(_E_, 1).

rcp_minimize_completion_time_search(_E_) :- 
	rcp_cost(_D_),
	minimize((((rcp_tasks_search(_B_),variables(_B_,_C_)),(rcp_disjunctives_search(_A_),rcp_assert(_A_)),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_),
	fd_aeq(_E_, 1).

solve([First,A1,A2,A3,A4,A5,A6,P1,P2,Ue,S1,S2,S3,S4,S5,S6,B1,B2,B3,B4,B5,B6,Ab1,Ab2,Ab3,Ab4,Ab5,Ab6,M1,M2,M3,M4,M5,M6,L1,T1,T2,T3,T4,T5,Ua,V1,V2,K1,K2,Last]) :- 
	statistics(runtime, [_Runtime_0_|_]),
	
	rcp_var(from(first,0,1), First),
	rcp_var(from(a1,0,1), A1),
	rcp_var(from(a2,0,1), A2),
	rcp_var(from(a3,0,1), A3),
	rcp_var(from(a4,0,1), A4),
	rcp_var(from(a5,0,1), A5),
	rcp_var(from(a6,0,1), A6),
	rcp_var(from(p1,0,1), P1),
	rcp_var(from(p2,0,1), P2),
	rcp_var(from(ue,0,1), Ue),
	rcp_var(from(s1,0,1), S1),
	rcp_var(from(s2,0,1), S2),
	rcp_var(from(s3,0,1), S3),
	rcp_var(from(s4,0,1), S4),
	rcp_var(from(s5,0,1), S5),
	rcp_var(from(s6,0,1), S6),
	rcp_var(from(b1,0,1), B1),
	rcp_var(from(b2,0,1), B2),
	rcp_var(from(b3,0,1), B3),
	rcp_var(from(b4,0,1), B4),
	rcp_var(from(b5,0,1), B5),
	rcp_var(from(b6,0,1), B6),
	rcp_var(from(ab1,0,1), Ab1),
	rcp_var(from(ab2,0,1), Ab2),
	rcp_var(from(ab3,0,1), Ab3),
	rcp_var(from(ab4,0,1), Ab4),
	rcp_var(from(ab5,0,1), Ab5),
	rcp_var(from(ab6,0,1), Ab6),
	rcp_var(from(m1,0,1), M1),
	rcp_var(from(m2,0,1), M2),
	rcp_var(from(m3,0,1), M3),
	rcp_var(from(m4,0,1), M4),
	rcp_var(from(m5,0,1), M5),
	rcp_var(from(m6,0,1), M6),
	rcp_var(from(l1,0,1), L1),
	rcp_var(from(t1,0,1), T1),
	rcp_var(from(t2,0,1), T2),
	rcp_var(from(t3,0,1), T3),
	rcp_var(from(t4,0,1), T4),
	rcp_var(from(t5,0,1), T5),
	rcp_var(from(ua,0,1), Ua),
	rcp_var(from(v1,0,1), V1),
	rcp_var(from(v2,0,1), V2),
	rcp_var(from(k1,0,1), K1),
	rcp_var(from(k2,0,1), K2),
	rcp_var(from(last,0,1), Last),
	domain([First,A1,A2,A3,A4,A5,A6,P1,P2,Ue,S1,S2,S3,S4,S5,S6,B1,B2,B3,B4,B5,B6,Ab1,Ab2,Ab3,Ab4,Ab5,Ab6,M1,M2,M3,M4,M5,M6,L1,T1,T2,T3,T4,T5,Ua,V1,V2,K1,K2,Last], 0, 271),
	First#=<A1,
	First#=<A2,
	First#=<A3,
	First#=<A4,
	First#=<A5,
	First#=<A6,
	First#=<Ue,
	A1+4#=<S1,
	A2+2#=<S2,
	A5+2#=<S5,
	A6+5#=<S6,
	A3+2#=<P1,
	A4+2#=<P2,
	P1+20#=<S3,
	P2+13#=<S4,
	P1+20#=<K1,
	P2+13#=<K1,
	S1+8#=<B1,
	S2+4#=<B2,
	S3+4#=<B3,
	S4+4#=<B4,
	S5+4#=<B5,
	S6+10#=<B6,
	B1+1#=<Ab1,
	B2+1#=<Ab2,
	B3+1#=<Ab3,
	B4+1#=<Ab4,
	B5+1#=<Ab5,
	B6+1#=<Ab6,
	Ab1+1#=<M1,
	Ab2+1#=<M2,
	Ab3+1#=<M3,
	Ab4+1#=<M4,
	Ab5+1#=<M5,
	Ab6+1#=<M6,
	M1+16#=<T1,
	M2+8#=<T1,
	M2+8#=<T2,
	M3+8#=<T2,
	M3+8#=<T3,
	M4+8#=<T3,
	M4+8#=<T4,
	M5+8#=<T4,
	M5+8#=<T5,
	M6+20#=<T5,
	M1+16#=<K2,
	M2+8#=<K2,
	M3+8#=<K2,
	M4+8#=<K2,
	M5+8#=<K2,
	M6+20#=<K2,
	L1+2#=<T1,
	L1+2#=<T2,
	L1+2#=<T3,
	L1+2#=<T4,
	L1+2#=<T5,
	T1+12#=<V1,
	T5+12#=<V2,
	T2+12#=<Last,
	T3+12#=<Last,
	T4+12#=<Last,
	V1+15#=<Last,
	V2+10#=<Last,
	Ua+10#=<Last,
	K1#=<Last,
	K2#=<Last,
	L1#=<First+30,
	S1#=<A1+4+3,
	S2#=<A2+2+3,
	S5#=<A5+2+3,
	S6#=<A6+5+3,
	S3#=<P1+20+3,
	S4#=<P2+13+3,
	M1+16#=<Ua+2,
	M2+8#=<Ua+2,
	M3+8#=<Ua+2,
	M4+8#=<Ua+2,
	M5+8#=<Ua+2,
	M6+20#=<Ua+2,
	B1+1#=<S1+8+4,
	B2+1#=<S2+4+4,
	B3+1#=<S3+4+4,
	B4+1#=<S4+4+4,
	B5+1#=<S5+4+4,
	B6+1#=<S6+10+4,
	L1#>=First+30,
	S1#>=Ue+6,
	S2#>=Ue+6,
	S3#>=Ue+6,
	S4#>=Ue+6,
	S5#>=Ue+6,
	S6#>=Ue+6,
	L1+2#=<T1#\/T1+12#=<L1,
	L1+2#=<T2#\/T2+12#=<L1,
	L1+2#=<T3#\/T3+12#=<L1,
	L1+2#=<T4#\/T4+12#=<L1,
	L1+2#=<T5#\/T5+12#=<L1,
	T1+12#=<T2#\/T2+12#=<T1,
	T1+12#=<T3#\/T3+12#=<T1,
	T1+12#=<T4#\/T4+12#=<T1,
	T1+12#=<T5#\/T5+12#=<T1,
	T2+12#=<T3#\/T3+12#=<T2,
	T2+12#=<T4#\/T4+12#=<T2,
	T2+12#=<T5#\/T5+12#=<T2,
	T3+12#=<T4#\/T4+12#=<T3,
	T3+12#=<T5#\/T5+12#=<T3,
	T4+12#=<T5#\/T5+12#=<T4,
	M1+16#=<M2#\/M2+8#=<M1,
	M1+16#=<M3#\/M3+8#=<M1,
	M1+16#=<M4#\/M4+8#=<M1,
	M1+16#=<M5#\/M5+8#=<M1,
	M1+16#=<M6#\/M6+20#=<M1,
	M2+8#=<M3#\/M3+8#=<M2,
	M2+8#=<M4#\/M4+8#=<M2,
	M2+8#=<M5#\/M5+8#=<M2,
	M2+8#=<M6#\/M6+20#=<M2,
	M3+8#=<M4#\/M4+8#=<M3,
	M3+8#=<M5#\/M5+8#=<M3,
	M3+8#=<M6#\/M6+20#=<M3,
	M4+8#=<M5#\/M5+8#=<M4,
	M4+8#=<M6#\/M6+20#=<M4,
	M5+8#=<M6#\/M6+20#=<M5,
	S1+8#=<S2#\/S2+4#=<S1,
	S1+8#=<S3#\/S3+4#=<S1,
	S1+8#=<S4#\/S4+4#=<S1,
	S1+8#=<S5#\/S5+4#=<S1,
	S1+8#=<S6#\/S6+10#=<S1,
	S2+4#=<S3#\/S3+4#=<S2,
	S2+4#=<S4#\/S4+4#=<S2,
	S2+4#=<S5#\/S5+4#=<S2,
	S2+4#=<S6#\/S6+10#=<S2,
	S3+4#=<S4#\/S4+4#=<S3,
	S3+4#=<S5#\/S5+4#=<S3,
	S3+4#=<S6#\/S6+10#=<S3,
	S4+4#=<S5#\/S5+4#=<S4,
	S4+4#=<S6#\/S6+10#=<S4,
	S5+4#=<S6#\/S6+10#=<S5,
	A1+4#=<A2#\/A2+2#=<A1,
	A1+4#=<A3#\/A3+2#=<A1,
	A1+4#=<A4#\/A4+2#=<A1,
	A1+4#=<A5#\/A5+2#=<A1,
	A1+4#=<A6#\/A6+5#=<A1,
	A2+2#=<A3#\/A3+2#=<A2,
	A2+2#=<A4#\/A4+2#=<A2,
	A2+2#=<A5#\/A5+2#=<A2,
	A2+2#=<A6#\/A6+5#=<A2,
	A3+2#=<A4#\/A4+2#=<A3,
	A3+2#=<A5#\/A5+2#=<A3,
	A3+2#=<A6#\/A6+5#=<A3,
	A4+2#=<A5#\/A5+2#=<A4,
	A4+2#=<A6#\/A6+5#=<A4,
	A5+2#=<A6#\/A6+5#=<A5,
	P1+20#=<P2#\/P2+13#=<P1,
	B1+1#=<B2#\/B2+1#=<B1,
	B1+1#=<B3#\/B3+1#=<B1,
	B1+1#=<B4#\/B4+1#=<B1,
	B1+1#=<B5#\/B5+1#=<B1,
	B1+1#=<B6#\/B6+1#=<B1,
	B2+1#=<B3#\/B3+1#=<B2,
	B2+1#=<B4#\/B4+1#=<B2,
	B2+1#=<B5#\/B5+1#=<B2,
	B2+1#=<B6#\/B6+1#=<B2,
	B3+1#=<B4#\/B4+1#=<B3,
	B3+1#=<B5#\/B5+1#=<B3,
	B3+1#=<B6#\/B6+1#=<B3,
	B4+1#=<B5#\/B5+1#=<B4,
	B4+1#=<B6#\/B6+1#=<B4,
	B5+1#=<B6#\/B6+1#=<B5,
	V1+15#=<V2#\/V2+10#=<V1,
	fd_statistics(backtracks, _),
	minimize(
		 (
		   fd_max(Last, MAX),
		   nl,write(MAX),nl,nl,
		   (
		     (write(prec(t1,l1)),nl,T1+12#=<L1;write(prec(l1,t1)),nl,L1+2#=<T1),
		     (write(prec(t2,l1)),nl,T2+12#=<L1;write(prec(l1,t2)),nl,L1+2#=<T2),
		     (write(prec(t3,l1)),nl,T3+12#=<L1;write(prec(l1,t3)),nl,L1+2#=<T3),
		     (write(prec(t4,l1)),nl,T4+12#=<L1;write(prec(l1,t4)),nl,L1+2#=<T4),
		     (write(prec(t5,l1)),nl,T5+12#=<L1;write(prec(l1,t5)),nl,L1+2#=<T5),
		     (write(prec(t1,t2)),nl,T1+12#=<T2;write(prec(t2,t1)),nl,T2+12#=<T1),
		     (write(prec(t1,t3)),nl,T1+12#=<T3;write(prec(t3,t1)),nl,T3+12#=<T1),
		     (write(prec(t1,t4)),nl,T1+12#=<T4;write(prec(t4,t1)),nl,T4+12#=<T1),
		     (write(prec(t1,t5)),nl,T1+12#=<T5;write(prec(t5,t1)),nl,T5+12#=<T1),
		     (write(prec(t2,t3)),nl,T2+12#=<T3;write(prec(t3,t2)),nl,T3+12#=<T2),
		     (write(prec(t2,t4)),nl,T2+12#=<T4;write(prec(t4,t2)),nl,T4+12#=<T2),
		     (write(prec(t2,t5)),nl,T2+12#=<T5;write(prec(t5,t2)),nl,T5+12#=<T2),
		     (write(prec(t3,t4)),nl,T3+12#=<T4;write(prec(t4,t3)),nl,T4+12#=<T3),
		     (write(prec(t3,t5)),nl,T3+12#=<T5;write(prec(t5,t3)),nl,T5+12#=<T3),
		     (write(prec(t4,t5)),nl,T4+12#=<T5;write(prec(t5,t4)),nl,T5+12#=<T4),
		     (write(prec(m1,m2)),nl,M1+16#=<M2;write(prec(m2,m1)),nl,M2+8#=<M1),
		     (write(prec(m1,m3)),nl,M1+16#=<M3;write(prec(m3,m1)),nl,M3+8#=<M1),
		     (write(prec(m1,m4)),nl,M1+16#=<M4;write(prec(m4,m1)),nl,M4+8#=<M1),
		     (write(prec(m1,m5)),nl,M1+16#=<M5;write(prec(m5,m1)),nl,M5+8#=<M1),
		     (write(prec(m6,m1)),nl,M6+20#=<M1;write(prec(m1,m6)),nl,M1+16#=<M6),
		     (write(prec(m2,m3)),nl,M2+8#=<M3;write(prec(m3,m2)),nl,M3+8#=<M2),
		     (write(prec(m2,m4)),nl,M2+8#=<M4;write(prec(m4,m2)),nl,M4+8#=<M2),
		     (write(prec(m2,m5)),nl,M2+8#=<M5;write(prec(m5,m2)),nl,M5+8#=<M2),
		     (write(prec(m6,m2)),nl,M6+20#=<M2;write(prec(m2,m6)),nl,M2+8#=<M6),
		     (write(prec(m3,m4)),nl,M3+8#=<M4;write(prec(m4,m3)),nl,M4+8#=<M3),
		     (write(prec(m3,m5)),nl,M3+8#=<M5;write(prec(m5,m3)),nl,M5+8#=<M3),
		     (write(prec(m6,m3)),nl,M6+20#=<M3;write(prec(m3,m6)),nl,M3+8#=<M6),
		     (write(prec(m4,m5)),nl,M4+8#=<M5;write(prec(m5,m4)),nl,M5+8#=<M4),
		     (write(prec(m6,m4)),nl,M6+20#=<M4;write(prec(m4,m6)),nl,M4+8#=<M6),
		     (write(prec(m6,m5)),nl,M6+20#=<M5;write(prec(m5,m6)),nl,M5+8#=<M6),
		     (write(prec(s1,s2)),nl,S1+8#=<S2;write(prec(s2,s1)),nl,S2+4#=<S1),
		     (write(prec(s1,s3)),nl,S1+8#=<S3;write(prec(s3,s1)),nl,S3+4#=<S1),
		     (write(prec(s1,s4)),nl,S1+8#=<S4;write(prec(s4,s1)),nl,S4+4#=<S1),
		     (write(prec(s1,s5)),nl,S1+8#=<S5;write(prec(s5,s1)),nl,S5+4#=<S1),
		     (write(prec(s6,s1)),nl,S6+10#=<S1;write(prec(s1,s6)),nl,S1+8#=<S6),
		     (write(prec(s2,s3)),nl,S2+4#=<S3;write(prec(s3,s2)),nl,S3+4#=<S2),
		     (write(prec(s2,s4)),nl,S2+4#=<S4;write(prec(s4,s2)),nl,S4+4#=<S2),
		     (write(prec(s2,s5)),nl,S2+4#=<S5;write(prec(s5,s2)),nl,S5+4#=<S2),
		     (write(prec(s6,s2)),nl,S6+10#=<S2;write(prec(s2,s6)),nl,S2+4#=<S6),
		     (write(prec(s3,s4)),nl,S3+4#=<S4;write(prec(s4,s3)),nl,S4+4#=<S3),
		     (write(prec(s3,s5)),nl,S3+4#=<S5;write(prec(s5,s3)),nl,S5+4#=<S3),
		     (write(prec(s6,s3)),nl,S6+10#=<S3;write(prec(s3,s6)),nl,S3+4#=<S6),
		     (write(prec(s4,s5)),nl,S4+4#=<S5;write(prec(s5,s4)),nl,S5+4#=<S4),
		     (write(prec(s6,s4)),nl,S6+10#=<S4;write(prec(s4,s6)),nl,S4+4#=<S6),
		     (write(prec(s6,s5)),nl,S6+10#=<S5;write(prec(s5,s6)),nl,S5+4#=<S6),
		     (write(prec(a1,a2)),nl,A1+4#=<A2;write(prec(a2,a1)),nl,A2+2#=<A1),
		     (write(prec(a1,a3)),nl,A1+4#=<A3;write(prec(a3,a1)),nl,A3+2#=<A1),
		     (write(prec(a1,a4)),nl,A1+4#=<A4;write(prec(a4,a1)),nl,A4+2#=<A1),
		     (write(prec(a1,a5)),nl,A1+4#=<A5;write(prec(a5,a1)),nl,A5+2#=<A1),
		     (write(prec(a6,a1)),nl,A6+5#=<A1;write(prec(a1,a6)),nl,A1+4#=<A6),
		     (write(prec(a2,a3)),nl,A2+2#=<A3;write(prec(a3,a2)),nl,A3+2#=<A2),
		     (write(prec(a2,a4)),nl,A2+2#=<A4;write(prec(a4,a2)),nl,A4+2#=<A2),
		     (write(prec(a2,a5)),nl,A2+2#=<A5;write(prec(a5,a2)),nl,A5+2#=<A2),
		     (write(prec(a6,a2)),nl,A6+5#=<A2;write(prec(a2,a6)),nl,A2+2#=<A6),
		     (write(prec(a3,a4)),nl,A3+2#=<A4;write(prec(a4,a3)),nl,A4+2#=<A3),
		     (write(prec(a3,a5)),nl,A3+2#=<A5;write(prec(a5,a3)),nl,A5+2#=<A3),
		     (write(prec(a6,a3)),nl,A6+5#=<A3;write(prec(a3,a6)),nl,A3+2#=<A6),
		     (write(prec(a4,a5)),nl,A4+2#=<A5;write(prec(a5,a4)),nl,A5+2#=<A4),
		     (write(prec(a6,a4)),nl,A6+5#=<A4;write(prec(a4,a6)),nl,A4+2#=<A6),
		     (write(prec(a6,a5)),nl,A6+5#=<A5;write(prec(a5,a6)),nl,A5+2#=<A6),
		     (write(prec(p1,p2)),nl,P1+20#=<P2;write(prec(p2,p1)),nl,P2+13#=<P1),
		     (write(prec(b1,b2)),nl,B1+1#=<B2;write(prec(b2,b1)),nl,B2+1#=<B1),
		     (write(prec(b1,b3)),nl,B1+1#=<B3;write(prec(b3,b1)),nl,B3+1#=<B1),
		     (write(prec(b1,b4)),nl,B1+1#=<B4;write(prec(b4,b1)),nl,B4+1#=<B1),
		     (write(prec(b1,b5)),nl,B1+1#=<B5;write(prec(b5,b1)),nl,B5+1#=<B1),
		     (write(prec(b1,b6)),nl,B1+1#=<B6;write(prec(b6,b1)),nl,B6+1#=<B1),
		     (write(prec(b2,b3)),nl,B2+1#=<B3;write(prec(b3,b2)),nl,B3+1#=<B2),
		     (write(prec(b2,b4)),nl,B2+1#=<B4;write(prec(b4,b2)),nl,B4+1#=<B2),
		     (write(prec(b2,b5)),nl,B2+1#=<B5;write(prec(b5,b2)),nl,B5+1#=<B2),
		     (write(prec(b2,b6)),nl,B2+1#=<B6;write(prec(b6,b2)),nl,B6+1#=<B2),
		     (write(prec(b3,b4)),nl,B3+1#=<B4;write(prec(b4,b3)),nl,B4+1#=<B3),
		     (write(prec(b3,b5)),nl,B3+1#=<B5;write(prec(b5,b3)),nl,B5+1#=<B3),
		     (write(prec(b3,b6)),nl,B3+1#=<B6;write(prec(b6,b3)),nl,B6+1#=<B3),
		     (write(prec(b4,b5)),nl,B4+1#=<B5;write(prec(b5,b4)),nl,B5+1#=<B4),
		     (write(prec(b4,b6)),nl,B4+1#=<B6;write(prec(b6,b4)),nl,B6+1#=<B4),
		     (write(prec(b5,b6)),nl,B5+1#=<B6;write(prec(b6,b5)),nl,B6+1#=<B5),
		     (write(prec(v1,v2)),nl,V1+15#=<V2;write(prec(v2,v1)),nl,V2+10#=<V1),
		     rcp_labeling([First,A1,A2,A3,A4,A5,A6,P1,P2,Ue,S1,S2,S3,S4,S5,S6,B1,B2,B3,B4,B5,B6,Ab1,Ab2,Ab3,Ab4,Ab5,Ab6,M1,M2,M3,M4,M5,M6,L1,T1,T2,T3,T4,T5,Ua,V1,V2,K1,K2,Last])
		   ),
		   rcp_labeling([Last])
		 ), Last),
	fd_statistics(backtracks, _Backtracks_),
	statistics(runtime, [_Runtime_1_|_]),

	_Runtime_ is _Runtime_1_-_Runtime_0_,
	format('~3d seconds\n', [_Runtime_]),
	format('~w bactracks\n\n', [_Backtracks_]).
