package rules2cp.examples.scheduling;
import static rules2cp.interpreter.java.r2cp.*;
import rules2cp.interpreter.java.*;
import java.util.Vector;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.cp.solver.search.integer.varselector.*;
import choco.cp.solver.search.integer.valselector.*;
import choco.cp.solver.search.integer.valiterator.*;
import choco.cp.solver.search.integer.branching.*;
import choco.cp.solver.constraints.integer.*;
import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.*;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.variables.geost.GeostObject;
import choco.kernel.solver.Solver;
import choco.kernel.solver.branch.*;
import choco.kernel.solver.variables.integer.*;
import choco.kernel.model.variables.geost.*;

public class bridge {

  public static void main(String[] args) {

    IntegerVariable ab1 = rcp_var("from(ab1, 1)");
    IntegerVariable ab2 = rcp_var("from(ab2, 1)");
    IntegerVariable ab3 = rcp_var("from(ab3, 1)");
    IntegerVariable ab4 = rcp_var("from(ab4, 1)");
    IntegerVariable ab5 = rcp_var("from(ab5, 1)");
    IntegerVariable ab6 = rcp_var("from(ab6, 1)");
    IntegerVariable k1 = rcp_var("from(k1, 1)");
    IntegerVariable k2 = rcp_var("from(k2, 1)");
    IntegerVariable last = rcp_var("from(last, 1)");
    IntegerVariable ua = rcp_var("from(ua, 1)");
    IntegerVariable first = rcp_var("from(first, 1)");
    IntegerVariable ue = rcp_var("from(ue, 1)");
    IntegerVariable reif_72 = makeIntVar("reif_72", 0, 1);
    IntegerVariable reif_73 = makeIntVar("reif_73", 0, 1);
    IntegerVariable p2 = rcp_var("from(p2, 1)");
    IntegerVariable p1 = rcp_var("from(p1, 1)");
    IntegerVariable reif_74 = makeIntVar("reif_74", 0, 1);
    IntegerVariable reif_75 = makeIntVar("reif_75", 0, 1);
    IntegerVariable reif_76 = makeIntVar("reif_76", 0, 1);
    IntegerVariable reif_77 = makeIntVar("reif_77", 0, 1);
    IntegerVariable m6 = rcp_var("from(m6, 1)");
    IntegerVariable reif_78 = makeIntVar("reif_78", 0, 1);
    IntegerVariable v2 = rcp_var("from(v2, 1)");
    IntegerVariable v1 = rcp_var("from(v1, 1)");
    IntegerVariable reif_79 = makeIntVar("reif_79", 0, 1);
    IntegerVariable reif_80 = makeIntVar("reif_80", 0, 1);
    IntegerVariable reif_81 = makeIntVar("reif_81", 0, 1);
    IntegerVariable reif_82 = makeIntVar("reif_82", 0, 1);
    IntegerVariable reif_83 = makeIntVar("reif_83", 0, 1);
    IntegerVariable reif_84 = makeIntVar("reif_84", 0, 1);
    IntegerVariable reif_85 = makeIntVar("reif_85", 0, 1);
    IntegerVariable reif_86 = makeIntVar("reif_86", 0, 1);
    IntegerVariable reif_87 = makeIntVar("reif_87", 0, 1);
    IntegerVariable reif_88 = makeIntVar("reif_88", 0, 1);
    IntegerVariable reif_89 = makeIntVar("reif_89", 0, 1);
    IntegerVariable reif_90 = makeIntVar("reif_90", 0, 1);
    IntegerVariable reif_91 = makeIntVar("reif_91", 0, 1);
    IntegerVariable reif_92 = makeIntVar("reif_92", 0, 1);
    IntegerVariable m1 = rcp_var("from(m1, 1)");
    IntegerVariable reif_93 = makeIntVar("reif_93", 0, 1);
    IntegerVariable reif_94 = makeIntVar("reif_94", 0, 1);
    IntegerVariable reif_95 = makeIntVar("reif_95", 0, 1);
    IntegerVariable reif_96 = makeIntVar("reif_96", 0, 1);
    IntegerVariable m2 = rcp_var("from(m2, 1)");
    IntegerVariable reif_97 = makeIntVar("reif_97", 0, 1);
    IntegerVariable reif_98 = makeIntVar("reif_98", 0, 1);
    IntegerVariable m3 = rcp_var("from(m3, 1)");
    IntegerVariable reif_99 = makeIntVar("reif_99", 0, 1);
    IntegerVariable m5 = rcp_var("from(m5, 1)");
    IntegerVariable m4 = rcp_var("from(m4, 1)");
    IntegerVariable reif_100 = makeIntVar("reif_100", 0, 1);
    IntegerVariable t1 = rcp_var("from(t1, 1)");
    IntegerVariable reif_101 = makeIntVar("reif_101", 0, 1);
    IntegerVariable t2 = rcp_var("from(t2, 1)");
    IntegerVariable reif_102 = makeIntVar("reif_102", 0, 1);
    IntegerVariable t3 = rcp_var("from(t3, 1)");
    IntegerVariable reif_103 = makeIntVar("reif_103", 0, 1);
    IntegerVariable t4 = rcp_var("from(t4, 1)");
    IntegerVariable reif_104 = makeIntVar("reif_104", 0, 1);
    IntegerVariable l1 = rcp_var("from(l1, 1)");
    IntegerVariable t5 = rcp_var("from(t5, 1)");
    IntegerVariable reif_105 = makeIntVar("reif_105", 0, 1);
    IntegerVariable reif_106 = makeIntVar("reif_106", 0, 1);
    IntegerVariable reif_107 = makeIntVar("reif_107", 0, 1);
    IntegerVariable reif_108 = makeIntVar("reif_108", 0, 1);
    IntegerVariable s6 = rcp_var("from(s6, 1)");
    IntegerVariable reif_109 = makeIntVar("reif_109", 0, 1);
    IntegerVariable reif_110 = makeIntVar("reif_110", 0, 1);
    IntegerVariable reif_111 = makeIntVar("reif_111", 0, 1);
    IntegerVariable reif_112 = makeIntVar("reif_112", 0, 1);
    IntegerVariable s1 = rcp_var("from(s1, 1)");
    IntegerVariable reif_113 = makeIntVar("reif_113", 0, 1);
    IntegerVariable reif_114 = makeIntVar("reif_114", 0, 1);
    IntegerVariable reif_115 = makeIntVar("reif_115", 0, 1);
    IntegerVariable reif_116 = makeIntVar("reif_116", 0, 1);
    IntegerVariable s2 = rcp_var("from(s2, 1)");
    IntegerVariable reif_117 = makeIntVar("reif_117", 0, 1);
    IntegerVariable reif_118 = makeIntVar("reif_118", 0, 1);
    IntegerVariable s3 = rcp_var("from(s3, 1)");
    IntegerVariable reif_119 = makeIntVar("reif_119", 0, 1);
    IntegerVariable s5 = rcp_var("from(s5, 1)");
    IntegerVariable s4 = rcp_var("from(s4, 1)");
    IntegerVariable reif_120 = makeIntVar("reif_120", 0, 1);
    IntegerVariable reif_121 = makeIntVar("reif_121", 0, 1);
    IntegerVariable reif_122 = makeIntVar("reif_122", 0, 1);
    IntegerVariable reif_123 = makeIntVar("reif_123", 0, 1);
    IntegerVariable a6 = rcp_var("from(a6, 1)");
    IntegerVariable reif_124 = makeIntVar("reif_124", 0, 1);
    IntegerVariable reif_125 = makeIntVar("reif_125", 0, 1);
    IntegerVariable reif_126 = makeIntVar("reif_126", 0, 1);
    IntegerVariable reif_127 = makeIntVar("reif_127", 0, 1);
    IntegerVariable a1 = rcp_var("from(a1, 1)");
    IntegerVariable reif_128 = makeIntVar("reif_128", 0, 1);
    IntegerVariable reif_129 = makeIntVar("reif_129", 0, 1);
    IntegerVariable reif_130 = makeIntVar("reif_130", 0, 1);
    IntegerVariable a2 = rcp_var("from(a2, 1)");
    IntegerVariable reif_131 = makeIntVar("reif_131", 0, 1);
    IntegerVariable reif_132 = makeIntVar("reif_132", 0, 1);
    IntegerVariable a3 = rcp_var("from(a3, 1)");
    IntegerVariable reif_133 = makeIntVar("reif_133", 0, 1);
    IntegerVariable a5 = rcp_var("from(a5, 1)");
    IntegerVariable a4 = rcp_var("from(a4, 1)");
    IntegerVariable reif_134 = makeIntVar("reif_134", 0, 1);
    IntegerVariable reif_135 = makeIntVar("reif_135", 0, 1);
    IntegerVariable reif_136 = makeIntVar("reif_136", 0, 1);
    IntegerVariable reif_137 = makeIntVar("reif_137", 0, 1);
    IntegerVariable reif_138 = makeIntVar("reif_138", 0, 1);
    IntegerVariable b1 = rcp_var("from(b1, 1)");
    IntegerVariable reif_139 = makeIntVar("reif_139", 0, 1);
    IntegerVariable reif_140 = makeIntVar("reif_140", 0, 1);
    IntegerVariable reif_141 = makeIntVar("reif_141", 0, 1);
    IntegerVariable reif_142 = makeIntVar("reif_142", 0, 1);
    IntegerVariable b2 = rcp_var("from(b2, 1)");
    IntegerVariable reif_143 = makeIntVar("reif_143", 0, 1);
    IntegerVariable reif_144 = makeIntVar("reif_144", 0, 1);
    IntegerVariable reif_145 = makeIntVar("reif_145", 0, 1);
    IntegerVariable b3 = rcp_var("from(b3, 1)");
    IntegerVariable reif_146 = makeIntVar("reif_146", 0, 1);
    IntegerVariable reif_147 = makeIntVar("reif_147", 0, 1);
    IntegerVariable b4 = rcp_var("from(b4, 1)");
    IntegerVariable reif_148 = makeIntVar("reif_148", 0, 1);
    IntegerVariable b6 = rcp_var("from(b6, 1)");
    IntegerVariable b5 = rcp_var("from(b5, 1)");
    domain(new IntegerVariable[] {first, a1, a2, a3, a4, a5, a6, p1, p2, ue, s1, s2, s3, s4, s5, s6, b1, b2, b3, b4, b5, b6, ab1, ab2, ab3, ab4, ab5, ab6, m1, m2, m3, m4, m5, m6, l1, t1, t2, t3, t4, t5, ua, v1, v2, k1, k2, last}, 0, 200);
    addConstraint(leq(first, a1));
    addConstraint(leq(first, a2));
    addConstraint(leq(first, a3));
    addConstraint(leq(first, a4));
    addConstraint(leq(first, a5));
    addConstraint(leq(first, a6));
    addConstraint(leq(first, ue));
    addConstraint(leq(plus(a1, 4), s1));
    addConstraint(leq(plus(a2, 2), s2));
    addConstraint(leq(plus(a5, 2), s5));
    addConstraint(leq(plus(a6, 5), s6));
    addConstraint(leq(plus(a3, 2), p1));
    addConstraint(leq(plus(a4, 2), p2));
    addConstraint(leq(plus(p1, 20), s3));
    addConstraint(leq(plus(p2, 13), s4));
    addConstraint(leq(plus(p1, 20), k1));
    addConstraint(leq(plus(p2, 13), k1));
    addConstraint(leq(plus(s1, 8), b1));
    addConstraint(leq(plus(s2, 4), b2));
    addConstraint(leq(plus(s3, 4), b3));
    addConstraint(leq(plus(s4, 4), b4));
    addConstraint(leq(plus(s5, 4), b5));
    addConstraint(leq(plus(s6, 10), b6));
    addConstraint(leq(plus(b1, 1), ab1));
    addConstraint(leq(plus(b2, 1), ab2));
    addConstraint(leq(plus(b3, 1), ab3));
    addConstraint(leq(plus(b4, 1), ab4));
    addConstraint(leq(plus(b5, 1), ab5));
    addConstraint(leq(plus(b6, 1), ab6));
    addConstraint(leq(plus(ab1, 1), m1));
    addConstraint(leq(plus(ab2, 1), m2));
    addConstraint(leq(plus(ab3, 1), m3));
    addConstraint(leq(plus(ab4, 1), m4));
    addConstraint(leq(plus(ab5, 1), m5));
    addConstraint(leq(plus(ab6, 1), m6));
    addConstraint(leq(plus(m1, 16), t1));
    addConstraint(leq(plus(m2, 8), t1));
    addConstraint(leq(plus(m2, 8), t2));
    addConstraint(leq(plus(m3, 8), t2));
    addConstraint(leq(plus(m3, 8), t3));
    addConstraint(leq(plus(m4, 8), t3));
    addConstraint(leq(plus(m4, 8), t4));
    addConstraint(leq(plus(m5, 8), t4));
    addConstraint(leq(plus(m5, 8), t5));
    addConstraint(leq(plus(m6, 20), t5));
    addConstraint(leq(plus(m1, 16), k2));
    addConstraint(leq(plus(m2, 8), k2));
    addConstraint(leq(plus(m3, 8), k2));
    addConstraint(leq(plus(m4, 8), k2));
    addConstraint(leq(plus(m5, 8), k2));
    addConstraint(leq(plus(m6, 20), k2));
    addConstraint(leq(plus(l1, 2), t1));
    addConstraint(leq(plus(l1, 2), t2));
    addConstraint(leq(plus(l1, 2), t3));
    addConstraint(leq(plus(l1, 2), t4));
    addConstraint(leq(plus(l1, 2), t5));
    addConstraint(leq(plus(t1, 12), v1));
    addConstraint(leq(plus(t5, 12), v2));
    addConstraint(leq(plus(t2, 12), last));
    addConstraint(leq(plus(t3, 12), last));
    addConstraint(leq(plus(t4, 12), last));
    addConstraint(leq(plus(v1, 15), last));
    addConstraint(leq(plus(v2, 10), last));
    addConstraint(leq(plus(ua, 10), last));
    addConstraint(leq(k1, last));
    addConstraint(leq(k2, last));
    addConstraint(leq(l1, plus(first, 30)));
    addConstraint(leq(s1, plus(plus(a1, 4), 3)));
    addConstraint(leq(s2, plus(plus(a2, 2), 3)));
    addConstraint(leq(s5, plus(plus(a5, 2), 3)));
    addConstraint(leq(s6, plus(plus(a6, 5), 3)));
    addConstraint(leq(s3, plus(plus(p1, 20), 3)));
    addConstraint(leq(s4, plus(plus(p2, 13), 3)));
    addConstraint(leq(plus(m1, 16), plus(ua, 2)));
    addConstraint(leq(plus(m2, 8), plus(ua, 2)));
    addConstraint(leq(plus(m3, 8), plus(ua, 2)));
    addConstraint(leq(plus(m4, 8), plus(ua, 2)));
    addConstraint(leq(plus(m5, 8), plus(ua, 2)));
    addConstraint(leq(plus(m6, 20), plus(ua, 2)));
    addConstraint(leq(plus(b1, 1), plus(plus(s1, 8), 4)));
    addConstraint(leq(plus(b2, 1), plus(plus(s2, 4), 4)));
    addConstraint(leq(plus(b3, 1), plus(plus(s3, 4), 4)));
    addConstraint(leq(plus(b4, 1), plus(plus(s4, 4), 4)));
    addConstraint(leq(plus(b5, 1), plus(plus(s5, 4), 4)));
    addConstraint(leq(plus(b6, 1), plus(plus(s6, 10), 4)));
    addConstraint(geq(l1, plus(first, 30)));
    addConstraint(geq(s1, plus(ue, 6)));
    addConstraint(geq(s2, plus(ue, 6)));
    addConstraint(geq(s3, plus(ue, 6)));
    addConstraint(geq(s4, plus(ue, 6)));
    addConstraint(geq(s5, plus(ue, 6)));
    addConstraint(geq(s6, plus(ue, 6)));
    addConstraint(and(and(ifOnlyIf(eq(reif_72, 1), leq(plus(m6, 20), m1)), ifOnlyIf(eq(reif_72, 0), leq(plus(m1, 16), m6))), and(and(ifOnlyIf(eq(reif_73, 1), leq(plus(p1, 20), p2)), ifOnlyIf(eq(reif_73, 0), leq(plus(p2, 13), p1))), and(and(ifOnlyIf(eq(reif_74, 1), leq(plus(m6, 20), m2)), ifOnlyIf(eq(reif_74, 0), leq(plus(m2, 8), m6))), and(and(ifOnlyIf(eq(reif_75, 1), leq(plus(m6, 20), m3)), ifOnlyIf(eq(reif_75, 0), leq(plus(m3, 8), m6))), and(and(ifOnlyIf(eq(reif_76, 1), leq(plus(m6, 20), m4)), ifOnlyIf(eq(reif_76, 0), leq(plus(m4, 8), m6))), and(and(ifOnlyIf(eq(reif_77, 1), leq(plus(m6, 20), m5)), ifOnlyIf(eq(reif_77, 0), leq(plus(m5, 8), m6))), and(and(ifOnlyIf(eq(reif_78, 1), leq(plus(v1, 15), v2)), ifOnlyIf(eq(reif_78, 0), leq(plus(v2, 10), v1))), and(and(ifOnlyIf(eq(reif_79, 1), leq(plus(t1, 12), t2)), ifOnlyIf(eq(reif_79, 0), leq(plus(t2, 12), t1))), and(and(ifOnlyIf(eq(reif_80, 1), leq(plus(t1, 12), t3)), ifOnlyIf(eq(reif_80, 0), leq(plus(t3, 12), t1))), and(and(ifOnlyIf(eq(reif_81, 1), leq(plus(t1, 12), t4)), ifOnlyIf(eq(reif_81, 0), leq(plus(t4, 12), t1))), and(and(ifOnlyIf(eq(reif_82, 1), leq(plus(t1, 12), t5)), ifOnlyIf(eq(reif_82, 0), leq(plus(t5, 12), t1))), and(and(ifOnlyIf(eq(reif_83, 1), leq(plus(t2, 12), t3)), ifOnlyIf(eq(reif_83, 0), leq(plus(t3, 12), t2))), and(and(ifOnlyIf(eq(reif_84, 1), leq(plus(t2, 12), t4)), ifOnlyIf(eq(reif_84, 0), leq(plus(t4, 12), t2))), and(and(ifOnlyIf(eq(reif_85, 1), leq(plus(t2, 12), t5)), ifOnlyIf(eq(reif_85, 0), leq(plus(t5, 12), t2))), and(and(ifOnlyIf(eq(reif_86, 1), leq(plus(t3, 12), t4)), ifOnlyIf(eq(reif_86, 0), leq(plus(t4, 12), t3))), and(and(ifOnlyIf(eq(reif_87, 1), leq(plus(t3, 12), t5)), ifOnlyIf(eq(reif_87, 0), leq(plus(t5, 12), t3))), and(and(ifOnlyIf(eq(reif_88, 1), leq(plus(t4, 12), t5)), ifOnlyIf(eq(reif_88, 0), leq(plus(t5, 12), t4))), and(and(ifOnlyIf(eq(reif_89, 1), leq(plus(m1, 16), m2)), ifOnlyIf(eq(reif_89, 0), leq(plus(m2, 8), m1))), and(and(ifOnlyIf(eq(reif_90, 1), leq(plus(m1, 16), m3)), ifOnlyIf(eq(reif_90, 0), leq(plus(m3, 8), m1))), and(and(ifOnlyIf(eq(reif_91, 1), leq(plus(m1, 16), m4)), ifOnlyIf(eq(reif_91, 0), leq(plus(m4, 8), m1))), and(and(ifOnlyIf(eq(reif_92, 1), leq(plus(m1, 16), m5)), ifOnlyIf(eq(reif_92, 0), leq(plus(m5, 8), m1))), and(and(ifOnlyIf(eq(reif_93, 1), leq(plus(s6, 10), s1)), ifOnlyIf(eq(reif_93, 0), leq(plus(s1, 8), s6))), and(and(ifOnlyIf(eq(reif_94, 1), leq(plus(m2, 8), m3)), ifOnlyIf(eq(reif_94, 0), leq(plus(m3, 8), m2))), and(and(ifOnlyIf(eq(reif_95, 1), leq(plus(m2, 8), m4)), ifOnlyIf(eq(reif_95, 0), leq(plus(m4, 8), m2))), and(and(ifOnlyIf(eq(reif_96, 1), leq(plus(m2, 8), m5)), ifOnlyIf(eq(reif_96, 0), leq(plus(m5, 8), m2))), and(and(ifOnlyIf(eq(reif_97, 1), leq(plus(m3, 8), m4)), ifOnlyIf(eq(reif_97, 0), leq(plus(m4, 8), m3))), and(and(ifOnlyIf(eq(reif_98, 1), leq(plus(m3, 8), m5)), ifOnlyIf(eq(reif_98, 0), leq(plus(m5, 8), m3))), and(and(ifOnlyIf(eq(reif_99, 1), leq(plus(m4, 8), m5)), ifOnlyIf(eq(reif_99, 0), leq(plus(m5, 8), m4))), and(and(ifOnlyIf(eq(reif_100, 1), leq(plus(t1, 12), l1)), ifOnlyIf(eq(reif_100, 0), leq(plus(l1, 2), t1))), and(and(ifOnlyIf(eq(reif_101, 1), leq(plus(t2, 12), l1)), ifOnlyIf(eq(reif_101, 0), leq(plus(l1, 2), t2))), and(and(ifOnlyIf(eq(reif_102, 1), leq(plus(t3, 12), l1)), ifOnlyIf(eq(reif_102, 0), leq(plus(l1, 2), t3))), and(and(ifOnlyIf(eq(reif_103, 1), leq(plus(t4, 12), l1)), ifOnlyIf(eq(reif_103, 0), leq(plus(l1, 2), t4))), and(and(ifOnlyIf(eq(reif_104, 1), leq(plus(t5, 12), l1)), ifOnlyIf(eq(reif_104, 0), leq(plus(l1, 2), t5))), and(and(ifOnlyIf(eq(reif_105, 1), leq(plus(s6, 10), s2)), ifOnlyIf(eq(reif_105, 0), leq(plus(s2, 4), s6))), and(and(ifOnlyIf(eq(reif_106, 1), leq(plus(s6, 10), s3)), ifOnlyIf(eq(reif_106, 0), leq(plus(s3, 4), s6))), and(and(ifOnlyIf(eq(reif_107, 1), leq(plus(s6, 10), s4)), ifOnlyIf(eq(reif_107, 0), leq(plus(s4, 4), s6))), and(and(ifOnlyIf(eq(reif_108, 1), leq(plus(s6, 10), s5)), ifOnlyIf(eq(reif_108, 0), leq(plus(s5, 4), s6))), and(and(ifOnlyIf(eq(reif_109, 1), leq(plus(s1, 8), s2)), ifOnlyIf(eq(reif_109, 0), leq(plus(s2, 4), s1))), and(and(ifOnlyIf(eq(reif_110, 1), leq(plus(s1, 8), s3)), ifOnlyIf(eq(reif_110, 0), leq(plus(s3, 4), s1))), and(and(ifOnlyIf(eq(reif_111, 1), leq(plus(s1, 8), s4)), ifOnlyIf(eq(reif_111, 0), leq(plus(s4, 4), s1))), and(and(ifOnlyIf(eq(reif_112, 1), leq(plus(s1, 8), s5)), ifOnlyIf(eq(reif_112, 0), leq(plus(s5, 4), s1))), and(and(ifOnlyIf(eq(reif_113, 1), leq(plus(a6, 5), a1)), ifOnlyIf(eq(reif_113, 0), leq(plus(a1, 4), a6))), and(and(ifOnlyIf(eq(reif_114, 1), leq(plus(s2, 4), s3)), ifOnlyIf(eq(reif_114, 0), leq(plus(s3, 4), s2))), and(and(ifOnlyIf(eq(reif_115, 1), leq(plus(s2, 4), s4)), ifOnlyIf(eq(reif_115, 0), leq(plus(s4, 4), s2))), and(and(ifOnlyIf(eq(reif_116, 1), leq(plus(s2, 4), s5)), ifOnlyIf(eq(reif_116, 0), leq(plus(s5, 4), s2))), and(and(ifOnlyIf(eq(reif_117, 1), leq(plus(s3, 4), s4)), ifOnlyIf(eq(reif_117, 0), leq(plus(s4, 4), s3))), and(and(ifOnlyIf(eq(reif_118, 1), leq(plus(s3, 4), s5)), ifOnlyIf(eq(reif_118, 0), leq(plus(s5, 4), s3))), and(and(ifOnlyIf(eq(reif_119, 1), leq(plus(s4, 4), s5)), ifOnlyIf(eq(reif_119, 0), leq(plus(s5, 4), s4))), and(and(ifOnlyIf(eq(reif_120, 1), leq(plus(a6, 5), a2)), ifOnlyIf(eq(reif_120, 0), leq(plus(a2, 2), a6))), and(and(ifOnlyIf(eq(reif_121, 1), leq(plus(a6, 5), a3)), ifOnlyIf(eq(reif_121, 0), leq(plus(a3, 2), a6))), and(and(ifOnlyIf(eq(reif_122, 1), leq(plus(a6, 5), a4)), ifOnlyIf(eq(reif_122, 0), leq(plus(a4, 2), a6))), and(and(ifOnlyIf(eq(reif_123, 1), leq(plus(a6, 5), a5)), ifOnlyIf(eq(reif_123, 0), leq(plus(a5, 2), a6))), and(and(ifOnlyIf(eq(reif_124, 1), leq(plus(a1, 4), a2)), ifOnlyIf(eq(reif_124, 0), leq(plus(a2, 2), a1))), and(and(ifOnlyIf(eq(reif_125, 1), leq(plus(a1, 4), a3)), ifOnlyIf(eq(reif_125, 0), leq(plus(a3, 2), a1))), and(and(ifOnlyIf(eq(reif_126, 1), leq(plus(a1, 4), a4)), ifOnlyIf(eq(reif_126, 0), leq(plus(a4, 2), a1))), and(and(ifOnlyIf(eq(reif_127, 1), leq(plus(a1, 4), a5)), ifOnlyIf(eq(reif_127, 0), leq(plus(a5, 2), a1))), and(and(ifOnlyIf(eq(reif_128, 1), leq(plus(a2, 2), a3)), ifOnlyIf(eq(reif_128, 0), leq(plus(a3, 2), a2))), and(and(ifOnlyIf(eq(reif_129, 1), leq(plus(a2, 2), a4)), ifOnlyIf(eq(reif_129, 0), leq(plus(a4, 2), a2))), and(and(ifOnlyIf(eq(reif_130, 1), leq(plus(a2, 2), a5)), ifOnlyIf(eq(reif_130, 0), leq(plus(a5, 2), a2))), and(and(ifOnlyIf(eq(reif_131, 1), leq(plus(a3, 2), a4)), ifOnlyIf(eq(reif_131, 0), leq(plus(a4, 2), a3))), and(and(ifOnlyIf(eq(reif_132, 1), leq(plus(a3, 2), a5)), ifOnlyIf(eq(reif_132, 0), leq(plus(a5, 2), a3))), and(and(ifOnlyIf(eq(reif_133, 1), leq(plus(a4, 2), a5)), ifOnlyIf(eq(reif_133, 0), leq(plus(a5, 2), a4))), and(and(ifOnlyIf(eq(reif_134, 1), leq(plus(b1, 1), b2)), ifOnlyIf(eq(reif_134, 0), leq(plus(b2, 1), b1))), and(and(ifOnlyIf(eq(reif_135, 1), leq(plus(b1, 1), b3)), ifOnlyIf(eq(reif_135, 0), leq(plus(b3, 1), b1))), and(and(ifOnlyIf(eq(reif_136, 1), leq(plus(b1, 1), b4)), ifOnlyIf(eq(reif_136, 0), leq(plus(b4, 1), b1))), and(and(ifOnlyIf(eq(reif_137, 1), leq(plus(b1, 1), b5)), ifOnlyIf(eq(reif_137, 0), leq(plus(b5, 1), b1))), and(and(ifOnlyIf(eq(reif_138, 1), leq(plus(b1, 1), b6)), ifOnlyIf(eq(reif_138, 0), leq(plus(b6, 1), b1))), and(and(ifOnlyIf(eq(reif_139, 1), leq(plus(b2, 1), b3)), ifOnlyIf(eq(reif_139, 0), leq(plus(b3, 1), b2))), and(and(ifOnlyIf(eq(reif_140, 1), leq(plus(b2, 1), b4)), ifOnlyIf(eq(reif_140, 0), leq(plus(b4, 1), b2))), and(and(ifOnlyIf(eq(reif_141, 1), leq(plus(b2, 1), b5)), ifOnlyIf(eq(reif_141, 0), leq(plus(b5, 1), b2))), and(and(ifOnlyIf(eq(reif_142, 1), leq(plus(b2, 1), b6)), ifOnlyIf(eq(reif_142, 0), leq(plus(b6, 1), b2))), and(and(ifOnlyIf(eq(reif_143, 1), leq(plus(b3, 1), b4)), ifOnlyIf(eq(reif_143, 0), leq(plus(b4, 1), b3))), and(and(ifOnlyIf(eq(reif_144, 1), leq(plus(b3, 1), b5)), ifOnlyIf(eq(reif_144, 0), leq(plus(b5, 1), b3))), and(and(ifOnlyIf(eq(reif_145, 1), leq(plus(b3, 1), b6)), ifOnlyIf(eq(reif_145, 0), leq(plus(b6, 1), b3))), and(and(ifOnlyIf(eq(reif_146, 1), leq(plus(b4, 1), b5)), ifOnlyIf(eq(reif_146, 0), leq(plus(b5, 1), b4))), and(and(ifOnlyIf(eq(reif_147, 1), leq(plus(b4, 1), b6)), ifOnlyIf(eq(reif_147, 0), leq(plus(b6, 1), b4))), and(ifOnlyIf(eq(reif_148, 1), leq(plus(b5, 1), b6)), ifOnlyIf(eq(reif_148, 0), leq(plus(b6, 1), b5))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
    Solver s = new CPSolver();
    s.read(rules2cp.interpreter.java.r2cp.model);
    CPSolver.setVerbosity(CPSolver.SEARCH);
    s.attachGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {reif_72, reif_73, reif_74, reif_75, reif_76, reif_77, reif_78, reif_79, reif_80, reif_81, reif_82, reif_83, reif_84, reif_85, reif_86, reif_87, reif_88, reif_89, reif_90, reif_91, reif_92, reif_93, reif_94, reif_95, reif_96, reif_97, reif_98, reif_99, reif_100, reif_101, reif_102, reif_103, reif_104, reif_105, reif_106, reif_107, reif_108, reif_109, reif_110, reif_111, reif_112, reif_113, reif_114, reif_115, reif_116, reif_117, reif_118, reif_119, reif_120, reif_121, reif_122, reif_123, reif_124, reif_125, reif_126, reif_127, reif_128, reif_129, reif_130, reif_131, reif_132, reif_133, reif_134, reif_135, reif_136, reif_137, reif_138, reif_139, reif_140, reif_141, reif_142, reif_143, reif_144, reif_145, reif_146, reif_147, reif_148})), new DecreasingDomain()));
    s.minimize(s.getVar(last), true);
    CPSolver.flushLogs();
    System.out.println(s.pretty());
    
  }

}
